/* themes-dialog.c generated by valac 0.44.0, the Vala compiler
 * generated from themes-dialog.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
   This file is part of GNOME Reversi, also known as Iagno.

   Copyright 2015, 2019 Arnaud Bonatti

   GNOME Reversi is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   GNOME Reversi is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNOME Reversi.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>

#define TYPE_THEMES_DIALOG (themes_dialog_get_type ())
#define THEMES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THEMES_DIALOG, ThemesDialog))
#define THEMES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THEMES_DIALOG, ThemesDialogClass))
#define IS_THEMES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THEMES_DIALOG))
#define IS_THEMES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THEMES_DIALOG))
#define THEMES_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THEMES_DIALOG, ThemesDialogClass))

typedef struct _ThemesDialog ThemesDialog;
typedef struct _ThemesDialogClass ThemesDialogClass;
typedef struct _ThemesDialogPrivate ThemesDialogPrivate;

#define TYPE_GAME_VIEW (game_view_get_type ())
#define GAME_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_VIEW, GameView))
#define GAME_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_VIEW, GameViewClass))
#define IS_GAME_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_VIEW))
#define IS_GAME_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_VIEW))
#define GAME_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_VIEW, GameViewClass))

typedef struct _GameView GameView;
typedef struct _GameViewClass GameViewClass;
enum  {
	THEMES_DIALOG_0_PROPERTY,
	THEMES_DIALOG_NUM_PROPERTIES
};
static GParamSpec* themes_dialog_properties[THEMES_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block4Data Block4Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_dir_close0(var) ((var == NULL) ? NULL : (var = (g_dir_close (var), NULL)))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _ThemesDialog {
	GtkDialog parent_instance;
	ThemesDialogPrivate * priv;
};

struct _ThemesDialogClass {
	GtkDialogClass parent_class;
};

struct _ThemesDialogPrivate {
	GameView* view;
	GtkListBox* listbox;
};

struct _Block4Data {
	int _ref_count_;
	ThemesDialog* self;
	GSettings* settings;
	GameView* view;
};

static gint ThemesDialog_private_offset;
static gpointer themes_dialog_parent_class = NULL;

GType themes_dialog_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ThemesDialog, g_object_unref)
GType game_view_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameView, g_object_unref)
#define THEMES_DIALOG_PREFIX "theme-"
ThemesDialog* themes_dialog_new (GSettings* settings,
                                 GameView* view);
ThemesDialog* themes_dialog_construct (GType object_type,
                                       GSettings* settings,
                                       GameView* view);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static gboolean themes_dialog_do_not_close (ThemesDialog* self,
                                     GtkWidget* widget,
                                     GdkEventAny* event);
static gboolean _themes_dialog_do_not_close_gtk_widget_delete_event (GtkWidget* _sender,
                                                              GdkEventAny* event,
                                                              gpointer self);
static void ___lambda8_ (Block4Data* _data4_,
                  GtkListBoxRow* row);
void game_view_set_theme (GameView* self,
                          const gchar* value);
static void ____lambda8__gtk_list_box_row_selected (GtkListBox* _sender,
                                             GtkListBoxRow* row,
                                             gpointer self);
static void themes_dialog_finalize (GObject * obj);

static inline gpointer
themes_dialog_get_instance_private (ThemesDialog* self)
{
	return G_STRUCT_MEMBER_P (self, ThemesDialog_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 32 "../src/themes-dialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 129 "themes-dialog.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 32 "../src/themes-dialog.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 32 "../src/themes-dialog.vala"
	return _data4_;
#line 139 "themes-dialog.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 32 "../src/themes-dialog.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 149 "themes-dialog.c"
		ThemesDialog* self;
#line 32 "../src/themes-dialog.vala"
		self = _data4_->self;
#line 32 "../src/themes-dialog.vala"
		_g_object_unref0 (_data4_->settings);
#line 32 "../src/themes-dialog.vala"
		_g_object_unref0 (_data4_->view);
#line 32 "../src/themes-dialog.vala"
		_g_object_unref0 (self);
#line 32 "../src/themes-dialog.vala"
		g_slice_free (Block4Data, _data4_);
#line 161 "themes-dialog.c"
	}
}

static gboolean
_themes_dialog_do_not_close_gtk_widget_delete_event (GtkWidget* _sender,
                                                     GdkEventAny* event,
                                                     gpointer self)
{
	gboolean result;
	result = themes_dialog_do_not_close ((ThemesDialog*) self, _sender, event);
#line 42 "../src/themes-dialog.vala"
	return result;
#line 174 "themes-dialog.c"
}

static void
___lambda8_ (Block4Data* _data4_,
             GtkListBoxRow* row)
{
	ThemesDialog* self;
	gchar* view_theme = NULL;
	GtkWidget* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	gconstpointer _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
#line 94 "../src/themes-dialog.vala"
	self = _data4_->self;
#line 95 "../src/themes-dialog.vala"
	if (row == NULL) {
#line 96 "../src/themes-dialog.vala"
		return;
#line 199 "themes-dialog.c"
	}
#line 98 "../src/themes-dialog.vala"
	_tmp0_ = gtk_bin_get_child ((GtkBin*) G_TYPE_CHECK_INSTANCE_CAST (row, gtk_list_box_row_get_type (), GtkListBoxRow));
#line 98 "../src/themes-dialog.vala"
	_tmp1_ = gtk_container_get_children ((GtkContainer*) G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_box_get_type (), GtkBox));
#line 98 "../src/themes-dialog.vala"
	_tmp2_ = _tmp1_;
#line 98 "../src/themes-dialog.vala"
	_tmp3_ = g_list_nth_data (_tmp2_, (guint) 2);
#line 98 "../src/themes-dialog.vala"
	_tmp4_ = gtk_label_get_label (G_TYPE_CHECK_INSTANCE_CAST ((GtkWidget*) _tmp3_, gtk_label_get_type (), GtkLabel));
#line 98 "../src/themes-dialog.vala"
	_tmp5_ = _tmp4_;
#line 98 "../src/themes-dialog.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 98 "../src/themes-dialog.vala"
	_tmp7_ = _tmp6_;
#line 98 "../src/themes-dialog.vala"
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (g_list_free (_tmp2_), NULL));
#line 98 "../src/themes-dialog.vala"
	view_theme = _tmp7_;
#line 99 "../src/themes-dialog.vala"
	_tmp8_ = view_theme;
#line 99 "../src/themes-dialog.vala"
	game_view_set_theme (_data4_->view, _tmp8_);
#line 101 "../src/themes-dialog.vala"
	_tmp9_ = view_theme;
#line 101 "../src/themes-dialog.vala"
	g_settings_set_string (_data4_->settings, "theme", _tmp9_);
#line 102 "../src/themes-dialog.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 94 "../src/themes-dialog.vala"
	_g_free0 (view_theme);
#line 233 "themes-dialog.c"
}

static void
____lambda8__gtk_list_box_row_selected (GtkListBox* _sender,
                                        GtkListBoxRow* row,
                                        gpointer self)
{
#line 94 "../src/themes-dialog.vala"
	___lambda8_ (self, row);
#line 243 "themes-dialog.c"
}

ThemesDialog*
themes_dialog_construct (GType object_type,
                         GSettings* settings,
                         GameView* view)
{
	ThemesDialog * self = NULL;
	Block4Data* _data4_;
	GSettings* _tmp0_;
	GameView* _tmp1_;
	GtkSettings* gtk_settings = NULL;
	GtkSettings* _tmp2_;
	GtkSettings* _tmp3_;
	gint use_header_bar = 0;
	gboolean _tmp4_ = FALSE;
	GtkSettings* _tmp5_;
	GameView* _tmp9_;
	GDir* dir = NULL;
	GError* _inner_error0_ = NULL;
#line 32 "../src/themes-dialog.vala"
	g_return_val_if_fail (settings != NULL, NULL);
#line 32 "../src/themes-dialog.vala"
	g_return_val_if_fail (view != NULL, NULL);
#line 32 "../src/themes-dialog.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 32 "../src/themes-dialog.vala"
	_data4_->_ref_count_ = 1;
#line 32 "../src/themes-dialog.vala"
	_tmp0_ = _g_object_ref0 (settings);
#line 32 "../src/themes-dialog.vala"
	_g_object_unref0 (_data4_->settings);
#line 32 "../src/themes-dialog.vala"
	_data4_->settings = _tmp0_;
#line 32 "../src/themes-dialog.vala"
	_tmp1_ = _g_object_ref0 (view);
#line 32 "../src/themes-dialog.vala"
	_g_object_unref0 (_data4_->view);
#line 32 "../src/themes-dialog.vala"
	_data4_->view = _tmp1_;
#line 34 "../src/themes-dialog.vala"
	_tmp2_ = gtk_settings_get_default ();
#line 34 "../src/themes-dialog.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 34 "../src/themes-dialog.vala"
	gtk_settings = _tmp3_;
#line 36 "../src/themes-dialog.vala"
	_tmp5_ = gtk_settings;
#line 36 "../src/themes-dialog.vala"
	if (_tmp5_ != NULL) {
#line 294 "themes-dialog.c"
		GtkSettings* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 36 "../src/themes-dialog.vala"
		_tmp6_ = gtk_settings;
#line 36 "../src/themes-dialog.vala"
		g_object_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_settings_get_type (), GtkSettings), "gtk-dialogs-use-header", &_tmp7_, NULL);
#line 36 "../src/themes-dialog.vala"
		_tmp8_ = _tmp7_;
#line 36 "../src/themes-dialog.vala"
		_tmp4_ = !_tmp8_;
#line 306 "themes-dialog.c"
	} else {
#line 36 "../src/themes-dialog.vala"
		_tmp4_ = FALSE;
#line 310 "themes-dialog.c"
	}
#line 36 "../src/themes-dialog.vala"
	if (_tmp4_) {
#line 37 "../src/themes-dialog.vala"
		use_header_bar = 0;
#line 316 "themes-dialog.c"
	} else {
#line 39 "../src/themes-dialog.vala"
		use_header_bar = 1;
#line 320 "themes-dialog.c"
	}
#line 40 "../src/themes-dialog.vala"
	self = (ThemesDialog*) g_object_new (object_type, "use-header-bar", use_header_bar, NULL);
#line 40 "../src/themes-dialog.vala"
	_data4_->self = g_object_ref (self);
#line 41 "../src/themes-dialog.vala"
	_tmp9_ = _g_object_ref0 (_data4_->view);
#line 41 "../src/themes-dialog.vala"
	_g_object_unref0 (self->priv->view);
#line 41 "../src/themes-dialog.vala"
	self->priv->view = _tmp9_;
#line 42 "../src/themes-dialog.vala"
	g_signal_connect_object ((GtkWidget*) self, "delete-event", (GCallback) _themes_dialog_do_not_close_gtk_widget_delete_event, self, 0);
#line 334 "themes-dialog.c"
	{
		GDir* _tmp10_ = NULL;
		gchar* _tmp11_;
		gchar* _tmp12_;
		GDir* _tmp13_;
		GDir* _tmp14_;
		GDir* _tmp15_;
		GtkListBox* _tmp63_;
#line 48 "../src/themes-dialog.vala"
		_tmp11_ = g_build_filename (DATA_DIRECTORY, "themes", "key", NULL);
#line 48 "../src/themes-dialog.vala"
		_tmp12_ = _tmp11_;
#line 48 "../src/themes-dialog.vala"
		_tmp13_ = g_dir_open (_tmp12_, (guint) 0, &_inner_error0_);
#line 48 "../src/themes-dialog.vala"
		_tmp14_ = _tmp13_;
#line 48 "../src/themes-dialog.vala"
		_g_free0 (_tmp12_);
#line 48 "../src/themes-dialog.vala"
		_tmp10_ = _tmp14_;
#line 48 "../src/themes-dialog.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 48 "../src/themes-dialog.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 359 "themes-dialog.c"
				goto __catch6_g_file_error;
			}
#line 48 "../src/themes-dialog.vala"
			_g_dir_close0 (dir);
#line 48 "../src/themes-dialog.vala"
			_g_object_unref0 (gtk_settings);
#line 48 "../src/themes-dialog.vala"
			block4_data_unref (_data4_);
#line 48 "../src/themes-dialog.vala"
			_data4_ = NULL;
#line 48 "../src/themes-dialog.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 48 "../src/themes-dialog.vala"
			g_clear_error (&_inner_error0_);
#line 48 "../src/themes-dialog.vala"
			return NULL;
#line 376 "themes-dialog.c"
		}
#line 48 "../src/themes-dialog.vala"
		_tmp15_ = _tmp10_;
#line 48 "../src/themes-dialog.vala"
		_tmp10_ = NULL;
#line 48 "../src/themes-dialog.vala"
		_g_dir_close0 (dir);
#line 48 "../src/themes-dialog.vala"
		dir = _tmp15_;
#line 49 "../src/themes-dialog.vala"
		while (TRUE) {
#line 388 "themes-dialog.c"
			gchar* filename = NULL;
			GDir* _tmp16_;
			const gchar* _tmp17_;
			gchar* _tmp18_;
			const gchar* _tmp19_;
			gchar* path = NULL;
			const gchar* _tmp20_;
			gchar* _tmp21_;
			GKeyFile* key = NULL;
			GKeyFile* _tmp22_;
			gchar* name = NULL;
			GtkListBoxRow* row = NULL;
			GtkListBoxRow* _tmp31_;
			GtkListBoxRow* _tmp32_;
			GtkListBoxRow* _tmp33_;
			GtkBox* box = NULL;
			GtkBox* _tmp34_;
			GtkBox* _tmp35_;
			GtkImage* img = NULL;
			GtkImage* _tmp36_;
			GtkImage* _tmp37_;
			GtkImage* _tmp38_;
			GtkImage* _tmp39_;
			GtkLabel* lbl = NULL;
			const gchar* _tmp40_;
			GtkLabel* _tmp41_;
			GtkLabel* _tmp42_;
			GtkLabel* _tmp43_;
			GtkLabel* data = NULL;
			const gchar* _tmp44_;
			GtkLabel* _tmp45_;
			GtkLabel* _tmp46_;
			GtkBox* _tmp47_;
			GtkImage* _tmp48_;
			GtkBox* _tmp49_;
			GtkLabel* _tmp50_;
			GtkBox* _tmp51_;
			GtkLabel* _tmp52_;
			GtkListBoxRow* _tmp53_;
			GtkBox* _tmp54_;
			GtkListBox* _tmp55_;
			GtkListBoxRow* _tmp56_;
			const gchar* _tmp57_;
			gchar* _tmp58_;
			gchar* _tmp59_;
			gboolean _tmp60_;
#line 51 "../src/themes-dialog.vala"
			_tmp16_ = dir;
#line 51 "../src/themes-dialog.vala"
			_tmp17_ = g_dir_read_name (_tmp16_);
#line 51 "../src/themes-dialog.vala"
			_tmp18_ = g_strdup (_tmp17_);
#line 51 "../src/themes-dialog.vala"
			filename = _tmp18_;
#line 52 "../src/themes-dialog.vala"
			_tmp19_ = filename;
#line 52 "../src/themes-dialog.vala"
			if (_tmp19_ == NULL) {
#line 53 "../src/themes-dialog.vala"
				_g_free0 (filename);
#line 53 "../src/themes-dialog.vala"
				break;
#line 451 "themes-dialog.c"
			}
#line 55 "../src/themes-dialog.vala"
			_tmp20_ = filename;
#line 55 "../src/themes-dialog.vala"
			_tmp21_ = g_build_filename (DATA_DIRECTORY, "themes", "key", (const gchar*) _tmp20_, NULL);
#line 55 "../src/themes-dialog.vala"
			path = _tmp21_;
#line 56 "../src/themes-dialog.vala"
			_tmp22_ = g_key_file_new ();
#line 56 "../src/themes-dialog.vala"
			key = _tmp22_;
#line 463 "themes-dialog.c"
			{
				GKeyFile* _tmp23_;
				const gchar* _tmp24_;
				gchar* _tmp25_ = NULL;
				GKeyFile* _tmp26_;
				gchar* _tmp27_;
				gchar* _tmp28_;
#line 60 "../src/themes-dialog.vala"
				_tmp23_ = key;
#line 60 "../src/themes-dialog.vala"
				_tmp24_ = path;
#line 60 "../src/themes-dialog.vala"
				g_key_file_load_from_file (_tmp23_, _tmp24_, G_KEY_FILE_NONE, &_inner_error0_);
#line 60 "../src/themes-dialog.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 60 "../src/themes-dialog.vala"
					if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 481 "themes-dialog.c"
						goto __catch7_g_key_file_error;
					}
					goto __finally7;
				}
#line 61 "../src/themes-dialog.vala"
				_tmp26_ = key;
#line 61 "../src/themes-dialog.vala"
				_tmp27_ = g_key_file_get_locale_string (_tmp26_, "Theme", "Name", NULL, &_inner_error0_);
#line 61 "../src/themes-dialog.vala"
				_tmp25_ = _tmp27_;
#line 61 "../src/themes-dialog.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 61 "../src/themes-dialog.vala"
					if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 496 "themes-dialog.c"
						goto __catch7_g_key_file_error;
					}
#line 61 "../src/themes-dialog.vala"
					_g_free0 (name);
#line 61 "../src/themes-dialog.vala"
					_g_key_file_unref0 (key);
#line 61 "../src/themes-dialog.vala"
					_g_free0 (path);
#line 61 "../src/themes-dialog.vala"
					_g_free0 (filename);
#line 61 "../src/themes-dialog.vala"
					_g_dir_close0 (_tmp10_);
#line 61 "../src/themes-dialog.vala"
					_g_dir_close0 (dir);
#line 61 "../src/themes-dialog.vala"
					_g_object_unref0 (gtk_settings);
#line 61 "../src/themes-dialog.vala"
					block4_data_unref (_data4_);
#line 61 "../src/themes-dialog.vala"
					_data4_ = NULL;
#line 61 "../src/themes-dialog.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 61 "../src/themes-dialog.vala"
					g_clear_error (&_inner_error0_);
#line 61 "../src/themes-dialog.vala"
					return NULL;
#line 523 "themes-dialog.c"
				}
#line 61 "../src/themes-dialog.vala"
				_tmp28_ = _tmp25_;
#line 61 "../src/themes-dialog.vala"
				_tmp25_ = NULL;
#line 61 "../src/themes-dialog.vala"
				_g_free0 (name);
#line 61 "../src/themes-dialog.vala"
				name = _tmp28_;
#line 58 "../src/themes-dialog.vala"
				_g_free0 (_tmp25_);
#line 535 "themes-dialog.c"
			}
			goto __finally7;
			__catch7_g_key_file_error:
			{
				GError* e = NULL;
				GError* _tmp29_;
				const gchar* _tmp30_;
#line 58 "../src/themes-dialog.vala"
				e = _inner_error0_;
#line 58 "../src/themes-dialog.vala"
				_inner_error0_ = NULL;
#line 65 "../src/themes-dialog.vala"
				_tmp29_ = e;
#line 65 "../src/themes-dialog.vala"
				_tmp30_ = _tmp29_->message;
#line 65 "../src/themes-dialog.vala"
				g_warning ("themes-dialog.vala:65: oops: %s", _tmp30_);
#line 66 "../src/themes-dialog.vala"
				_g_error_free0 (e);
#line 66 "../src/themes-dialog.vala"
				_g_free0 (name);
#line 66 "../src/themes-dialog.vala"
				_g_key_file_unref0 (key);
#line 66 "../src/themes-dialog.vala"
				_g_free0 (path);
#line 66 "../src/themes-dialog.vala"
				_g_free0 (filename);
#line 66 "../src/themes-dialog.vala"
				continue;
#line 565 "themes-dialog.c"
			}
			__finally7:
#line 58 "../src/themes-dialog.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 58 "../src/themes-dialog.vala"
				_g_free0 (name);
#line 58 "../src/themes-dialog.vala"
				_g_key_file_unref0 (key);
#line 58 "../src/themes-dialog.vala"
				_g_free0 (path);
#line 58 "../src/themes-dialog.vala"
				_g_free0 (filename);
#line 58 "../src/themes-dialog.vala"
				_g_dir_close0 (_tmp10_);
#line 58 "../src/themes-dialog.vala"
				if (_inner_error0_->domain == G_FILE_ERROR) {
#line 582 "themes-dialog.c"
					goto __catch6_g_file_error;
				}
#line 58 "../src/themes-dialog.vala"
				_g_free0 (name);
#line 58 "../src/themes-dialog.vala"
				_g_key_file_unref0 (key);
#line 58 "../src/themes-dialog.vala"
				_g_free0 (path);
#line 58 "../src/themes-dialog.vala"
				_g_free0 (filename);
#line 58 "../src/themes-dialog.vala"
				_g_dir_close0 (_tmp10_);
#line 58 "../src/themes-dialog.vala"
				_g_dir_close0 (dir);
#line 58 "../src/themes-dialog.vala"
				_g_object_unref0 (gtk_settings);
#line 58 "../src/themes-dialog.vala"
				block4_data_unref (_data4_);
#line 58 "../src/themes-dialog.vala"
				_data4_ = NULL;
#line 58 "../src/themes-dialog.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 58 "../src/themes-dialog.vala"
				g_clear_error (&_inner_error0_);
#line 58 "../src/themes-dialog.vala"
				return NULL;
#line 609 "themes-dialog.c"
			}
#line 69 "../src/themes-dialog.vala"
			_tmp31_ = (GtkListBoxRow*) gtk_list_box_row_new ();
#line 69 "../src/themes-dialog.vala"
			g_object_ref_sink (_tmp31_);
#line 69 "../src/themes-dialog.vala"
			row = _tmp31_;
#line 70 "../src/themes-dialog.vala"
			_tmp32_ = row;
#line 70 "../src/themes-dialog.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp32_, TRUE);
#line 71 "../src/themes-dialog.vala"
			_tmp33_ = row;
#line 71 "../src/themes-dialog.vala"
			g_object_set ((GtkWidget*) _tmp33_, "height-request", 50, NULL);
#line 72 "../src/themes-dialog.vala"
			_tmp34_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 72 "../src/themes-dialog.vala"
			g_object_ref_sink (_tmp34_);
#line 72 "../src/themes-dialog.vala"
			box = _tmp34_;
#line 73 "../src/themes-dialog.vala"
			_tmp35_ = box;
#line 73 "../src/themes-dialog.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp35_, TRUE);
#line 74 "../src/themes-dialog.vala"
			_tmp36_ = (GtkImage*) gtk_image_new ();
#line 74 "../src/themes-dialog.vala"
			g_object_ref_sink (_tmp36_);
#line 74 "../src/themes-dialog.vala"
			img = _tmp36_;
#line 75 "../src/themes-dialog.vala"
			_tmp37_ = img;
#line 75 "../src/themes-dialog.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp37_, TRUE);
#line 76 "../src/themes-dialog.vala"
			_tmp38_ = img;
#line 76 "../src/themes-dialog.vala"
			g_object_set ((GtkWidget*) _tmp38_, "width-request", 50, NULL);
#line 77 "../src/themes-dialog.vala"
			_tmp39_ = img;
#line 77 "../src/themes-dialog.vala"
			g_object_set (_tmp39_, "icon-name", "object-select-symbolic", NULL);
#line 78 "../src/themes-dialog.vala"
			_tmp40_ = name;
#line 78 "../src/themes-dialog.vala"
			_tmp41_ = (GtkLabel*) gtk_label_new (_tmp40_);
#line 78 "../src/themes-dialog.vala"
			g_object_ref_sink (_tmp41_);
#line 78 "../src/themes-dialog.vala"
			lbl = _tmp41_;
#line 79 "../src/themes-dialog.vala"
			_tmp42_ = lbl;
#line 79 "../src/themes-dialog.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp42_, TRUE);
#line 80 "../src/themes-dialog.vala"
			_tmp43_ = lbl;
#line 80 "../src/themes-dialog.vala"
			gtk_label_set_xalign (_tmp43_, (gfloat) 0);
#line 81 "../src/themes-dialog.vala"
			_tmp44_ = filename;
#line 81 "../src/themes-dialog.vala"
			_tmp45_ = (GtkLabel*) gtk_label_new ((const gchar*) _tmp44_);
#line 81 "../src/themes-dialog.vala"
			g_object_ref_sink (_tmp45_);
#line 81 "../src/themes-dialog.vala"
			data = _tmp45_;
#line 82 "../src/themes-dialog.vala"
			_tmp46_ = data;
#line 82 "../src/themes-dialog.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp46_, FALSE);
#line 84 "../src/themes-dialog.vala"
			_tmp47_ = box;
#line 84 "../src/themes-dialog.vala"
			_tmp48_ = img;
#line 84 "../src/themes-dialog.vala"
			gtk_container_add ((GtkContainer*) _tmp47_, (GtkWidget*) _tmp48_);
#line 85 "../src/themes-dialog.vala"
			_tmp49_ = box;
#line 85 "../src/themes-dialog.vala"
			_tmp50_ = lbl;
#line 85 "../src/themes-dialog.vala"
			gtk_container_add ((GtkContainer*) _tmp49_, (GtkWidget*) _tmp50_);
#line 86 "../src/themes-dialog.vala"
			_tmp51_ = box;
#line 86 "../src/themes-dialog.vala"
			_tmp52_ = data;
#line 86 "../src/themes-dialog.vala"
			gtk_container_add ((GtkContainer*) _tmp51_, (GtkWidget*) _tmp52_);
#line 87 "../src/themes-dialog.vala"
			_tmp53_ = row;
#line 87 "../src/themes-dialog.vala"
			_tmp54_ = box;
#line 87 "../src/themes-dialog.vala"
			gtk_container_add ((GtkContainer*) _tmp53_, (GtkWidget*) _tmp54_);
#line 88 "../src/themes-dialog.vala"
			_tmp55_ = self->priv->listbox;
#line 88 "../src/themes-dialog.vala"
			_tmp56_ = row;
#line 88 "../src/themes-dialog.vala"
			gtk_container_add ((GtkContainer*) _tmp55_, (GtkWidget*) _tmp56_);
#line 90 "../src/themes-dialog.vala"
			_tmp57_ = filename;
#line 90 "../src/themes-dialog.vala"
			_tmp58_ = g_settings_get_string (_data4_->settings, "theme");
#line 90 "../src/themes-dialog.vala"
			_tmp59_ = _tmp58_;
#line 90 "../src/themes-dialog.vala"
			_tmp60_ = g_strcmp0 ((const gchar*) _tmp57_, _tmp59_) == 0;
#line 90 "../src/themes-dialog.vala"
			_g_free0 (_tmp59_);
#line 90 "../src/themes-dialog.vala"
			if (_tmp60_) {
#line 723 "themes-dialog.c"
				GtkListBox* _tmp61_;
				GtkListBoxRow* _tmp62_;
#line 91 "../src/themes-dialog.vala"
				_tmp61_ = self->priv->listbox;
#line 91 "../src/themes-dialog.vala"
				_tmp62_ = row;
#line 91 "../src/themes-dialog.vala"
				gtk_list_box_select_row (_tmp61_, _tmp62_);
#line 732 "themes-dialog.c"
			}
#line 49 "../src/themes-dialog.vala"
			_g_object_unref0 (data);
#line 49 "../src/themes-dialog.vala"
			_g_object_unref0 (lbl);
#line 49 "../src/themes-dialog.vala"
			_g_object_unref0 (img);
#line 49 "../src/themes-dialog.vala"
			_g_object_unref0 (box);
#line 49 "../src/themes-dialog.vala"
			_g_object_unref0 (row);
#line 49 "../src/themes-dialog.vala"
			_g_free0 (name);
#line 49 "../src/themes-dialog.vala"
			_g_key_file_unref0 (key);
#line 49 "../src/themes-dialog.vala"
			_g_free0 (path);
#line 49 "../src/themes-dialog.vala"
			_g_free0 (filename);
#line 752 "themes-dialog.c"
		}
#line 94 "../src/themes-dialog.vala"
		_tmp63_ = self->priv->listbox;
#line 94 "../src/themes-dialog.vala"
		g_signal_connect_data (_tmp63_, "row-selected", (GCallback) ____lambda8__gtk_list_box_row_selected, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
#line 46 "../src/themes-dialog.vala"
		_g_dir_close0 (_tmp10_);
#line 760 "themes-dialog.c"
	}
	goto __finally6;
	__catch6_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp64_;
		const gchar* _tmp65_;
#line 46 "../src/themes-dialog.vala"
		e = _inner_error0_;
#line 46 "../src/themes-dialog.vala"
		_inner_error0_ = NULL;
#line 107 "../src/themes-dialog.vala"
		_tmp64_ = e;
#line 107 "../src/themes-dialog.vala"
		_tmp65_ = _tmp64_->message;
#line 107 "../src/themes-dialog.vala"
		g_warning ("themes-dialog.vala:107: Failed to load themes: %s", _tmp65_);
#line 46 "../src/themes-dialog.vala"
		_g_error_free0 (e);
#line 780 "themes-dialog.c"
	}
	__finally6:
#line 46 "../src/themes-dialog.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 46 "../src/themes-dialog.vala"
		_g_dir_close0 (dir);
#line 46 "../src/themes-dialog.vala"
		_g_object_unref0 (gtk_settings);
#line 46 "../src/themes-dialog.vala"
		block4_data_unref (_data4_);
#line 46 "../src/themes-dialog.vala"
		_data4_ = NULL;
#line 46 "../src/themes-dialog.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 46 "../src/themes-dialog.vala"
		g_clear_error (&_inner_error0_);
#line 46 "../src/themes-dialog.vala"
		return NULL;
#line 799 "themes-dialog.c"
	}
#line 32 "../src/themes-dialog.vala"
	_g_dir_close0 (dir);
#line 32 "../src/themes-dialog.vala"
	_g_object_unref0 (gtk_settings);
#line 32 "../src/themes-dialog.vala"
	block4_data_unref (_data4_);
#line 32 "../src/themes-dialog.vala"
	_data4_ = NULL;
#line 32 "../src/themes-dialog.vala"
	return self;
#line 811 "themes-dialog.c"
}

ThemesDialog*
themes_dialog_new (GSettings* settings,
                   GameView* view)
{
#line 32 "../src/themes-dialog.vala"
	return themes_dialog_construct (TYPE_THEMES_DIALOG, settings, view);
#line 820 "themes-dialog.c"
}

static gboolean
themes_dialog_do_not_close (ThemesDialog* self,
                            GtkWidget* widget,
                            GdkEventAny* event)
{
	gboolean result = FALSE;
#line 111 "../src/themes-dialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 111 "../src/themes-dialog.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 111 "../src/themes-dialog.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 113 "../src/themes-dialog.vala"
	gtk_widget_hide (widget);
#line 114 "../src/themes-dialog.vala"
	result = TRUE;
#line 114 "../src/themes-dialog.vala"
	return result;
#line 841 "themes-dialog.c"
}

static void
themes_dialog_class_init (ThemesDialogClass * klass,
                          gpointer klass_data)
{
#line 24 "../src/themes-dialog.vala"
	themes_dialog_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/themes-dialog.vala"
	g_type_class_adjust_private_offset (klass, &ThemesDialog_private_offset);
#line 24 "../src/themes-dialog.vala"
	G_OBJECT_CLASS (klass)->finalize = themes_dialog_finalize;
#line 24 "../src/themes-dialog.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Reversi/ui/themes.ui");
#line 24 "../src/themes-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "listbox", FALSE, ThemesDialog_private_offset + G_STRUCT_OFFSET (ThemesDialogPrivate, listbox));
#line 858 "themes-dialog.c"
}

static void
themes_dialog_instance_init (ThemesDialog * self,
                             gpointer klass)
{
#line 24 "../src/themes-dialog.vala"
	self->priv = themes_dialog_get_instance_private (self);
#line 24 "../src/themes-dialog.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 869 "themes-dialog.c"
}

static void
themes_dialog_finalize (GObject * obj)
{
	ThemesDialog * self;
#line 24 "../src/themes-dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_THEMES_DIALOG, ThemesDialog);
#line 28 "../src/themes-dialog.vala"
	_g_object_unref0 (self->priv->view);
#line 30 "../src/themes-dialog.vala"
	_g_object_unref0 (self->priv->listbox);
#line 24 "../src/themes-dialog.vala"
	G_OBJECT_CLASS (themes_dialog_parent_class)->finalize (obj);
#line 884 "themes-dialog.c"
}

GType
themes_dialog_get_type (void)
{
	static volatile gsize themes_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&themes_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ThemesDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) themes_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ThemesDialog), 0, (GInstanceInitFunc) themes_dialog_instance_init, NULL };
		GType themes_dialog_type_id;
		themes_dialog_type_id = g_type_register_static (gtk_dialog_get_type (), "ThemesDialog", &g_define_type_info, 0);
		ThemesDialog_private_offset = g_type_add_instance_private (themes_dialog_type_id, sizeof (ThemesDialogPrivate));
		g_once_init_leave (&themes_dialog_type_id__volatile, themes_dialog_type_id);
	}
	return themes_dialog_type_id__volatile;
}

