/* game-view.c generated by valac 0.44.0, the Vala compiler
 * generated from game-view.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
   This file is part of GNOME Reversi, also known as Iagno.

   Copyright 2010-2013 Robert Ancell
   Copyright 2013-2014 Michael Catanzaro
   Copyright 2014-2019 Arnaud Bonatti

   GNOME Reversi is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   GNOME Reversi is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNOME Reversi.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <cairo.h>
#include <gdk/gdk.h>
#include <librsvg/rsvg.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

#define TYPE_GAME_VIEW (game_view_get_type ())
#define GAME_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_VIEW, GameView))
#define GAME_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_VIEW, GameViewClass))
#define IS_GAME_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_VIEW))
#define IS_GAME_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_VIEW))
#define GAME_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_VIEW, GameViewClass))

typedef struct _GameView GameView;
typedef struct _GameViewClass GameViewClass;
typedef struct _GameViewPrivate GameViewPrivate;

#define TYPE_GAME (game_get_type ())
#define GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME, Game))
#define GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME, GameClass))
#define IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME))
#define IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME))
#define GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME, GameClass))

typedef struct _Game Game;
typedef struct _GameClass GameClass;
typedef enum  {
	PLAYER_NONE,
	PLAYER_DARK,
	PLAYER_LIGHT
} Player;

#define TYPE_PLAYER (player_get_type ())
enum  {
	GAME_VIEW_0_PROPERTY,
	GAME_VIEW_SCOREBOARD_PROPERTY,
	GAME_VIEW_SOUND_FLIP_PROPERTY,
	GAME_VIEW_SOUND_GAMEOVER_PROPERTY,
	GAME_VIEW_GAME_PROPERTY,
	GAME_VIEW_THEME_PROPERTY,
	GAME_VIEW_NUM_PROPERTIES
};
static GParamSpec* game_view_properties[GAME_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _cairo_pattern_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_pattern_destroy (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
typedef struct _Block2Data Block2Data;
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
enum  {
	GAME_VIEW_MOVE_SIGNAL,
	GAME_VIEW_NUM_SIGNALS
};
static guint game_view_signals[GAME_VIEW_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GameView {
	GtkDrawingArea parent_instance;
	GameViewPrivate * priv;
};

struct _GameViewClass {
	GtkDrawingAreaClass parent_class;
};

struct _GameViewPrivate {
	GtkDrawingArea* _scoreboard;
	gchar* pieces_file;
	gdouble background_red;
	gdouble background_green;
	gdouble background_blue;
	gint background_radius;
	gdouble mark_red;
	gdouble mark_green;
	gdouble mark_blue;
	gint mark_width;
	gdouble border_red;
	gdouble border_green;
	gdouble border_blue;
	gint border_width;
	gdouble spacing_red;
	gdouble spacing_green;
	gdouble spacing_blue;
	gint spacing_width;
	gdouble highlight_red;
	gdouble highlight_green;
	gdouble highlight_blue;
	gdouble highlight_alpha;
	gchar* _sound_flip;
	gchar* _sound_gameover;
	gboolean show_highlight;
	gboolean highlight_set;
	guint8 highlight_x;
	guint8 highlight_y;
	guint8 highlight_state;
	guint render_size;
	cairo_pattern_t* tiles_pattern;
	cairo_pattern_t* scoreboard_tiles_pattern;
	gint* pixmaps;
	gint pixmaps_length1;
	gint pixmaps_length2;
	guint animate_timeout;
	gint current_player_number;
	gboolean game_is_set;
	guint8 game_size;
	Game* _game;
	gchar* _theme;
	gint paving_size;
	gint tile_size;
	gint board_size;
	gboolean flip_final_result_now;
	Player winning_color;
	gint n_winning_tiles;
	Player losing_color;
	gint n_losing_tiles;
};

struct _Block2Data {
	int _ref_count_;
	GameView* self;
	gboolean is_final_animation;
};

static gint GameView_private_offset;
static gpointer game_view_parent_class = NULL;

GType game_view_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameView, g_object_unref)
GType game_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Game, g_object_unref)
GType player_get_type (void) G_GNUC_CONST;
#define GAME_VIEW_HIGHLIGHT_MAX ((guint8) 5)
#define GAME_VIEW_PIXMAP_FLIP_DELAY 20
#define GAME_VIEW_HALF_PI (G_PI / 2.0)
static void game_view_set_default_theme (GameView* self,
                                  GKeyFile* * key);
static void game_view_load_theme (GameView* self,
                           GKeyFile* key);
static void game_view_set_sound_flip (GameView* self,
                               const gchar* value);
static void game_view_set_sound_gameover (GameView* self,
                                   const gchar* value);
static void game_view_calculate (GameView* self);
static gboolean game_view_real_draw (GtkWidget* base,
                              cairo_t* cr);
static void game_view_load_image (GameView* self,
                           cairo_t* c,
                           gint width,
                           gint height);
static gint game_view_get_board_x (GameView* self);
static gint game_view_get_board_y (GameView* self);
static void game_view_rounded_square (GameView* self,
                               cairo_t* cr,
                               gdouble x,
                               gdouble y,
                               gint size,
                               gdouble width,
                               gdouble radius_percent);
Game* game_view_get_game (GameView* self);
gboolean game_get_is_complete (Game* self);
static void game_view_square_changed_cb (GameView* self,
                                  guint8 x,
                                  guint8 y,
                                  Player replacement);
static void game_view_set_square (GameView* self,
                           guint8 x,
                           guint8 y,
                           gint pixmap,
                           gboolean is_final_animation,
                           gboolean force_redraw);
static gint game_view_get_pixmap (Player color);
Player game_get_owner (Game* self,
                       guint8 x,
                       guint8 y);
static inline void game_view_update_square (GameView* self,
                              guint8 x,
                              guint8 y);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static gboolean ____lambda7_ (Block2Data* _data2_);
static void game_view_flip_final_result_tile (GameView* self,
                                       guint8 x,
                                       guint8 y);
static gboolean _____lambda7__gsource_func (gpointer self);
static void game_view_game_is_complete_cb (GameView* self);
guint8 game_get_n_light_tiles (Game* self);
guint8 game_get_n_dark_tiles (Game* self);
static gboolean __lambda6_ (GameView* self);
static void game_view_set_winner_and_loser_variables (GameView* self);
static gboolean ___lambda6__gsource_func (gpointer self);
gboolean game_view_undo_final_animation (GameView* self);
static gboolean game_view_real_button_press_event (GtkWidget* base,
                                            GdkEventButton* event);
gboolean game_is_valid_location_signed (Game* self,
                                        gint8 x,
                                        gint8 y);
static gboolean game_view_real_key_press_event (GtkWidget* base,
                                         GdkEventKey* event);
Player game_get_current_color (Game* self);
static gboolean game_view_draw_scoreboard (GameView* self,
                                    cairo_t* cr);
static GtkDrawingArea* game_view_get_scoreboard (GameView* self);
void game_view_update_scoreboard (GameView* self);
GameView* game_view_new (void);
GameView* game_view_construct (GType object_type);
void game_view_set_scoreboard (GameView* self,
                               GtkDrawingArea* value);
static gboolean _game_view_draw_scoreboard_gtk_widget_draw (GtkWidget* _sender,
                                                     cairo_t* cr,
                                                     gpointer self);
const gchar* game_view_get_sound_flip (GameView* self);
const gchar* game_view_get_sound_gameover (GameView* self);
void game_view_set_game (GameView* self,
                         Game* value);
guint8 game_get_size (Game* self);
static void _game_view_game_is_complete_cb_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self);
static void _game_view_square_changed_cb_game_square_changed (Game* _sender,
                                                       guint8 x,
                                                       guint8 y,
                                                       Player new_color,
                                                       gpointer self);
gboolean game_get_alternative_start (Game* self);
const gchar* game_view_get_theme (GameView* self);
void game_view_set_theme (GameView* self,
                          const gchar* value);
static void g_cclosure_user_marshal_VOID__UCHAR_UCHAR (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static GObject * game_view_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties);
static void game_view_finalize (GObject * obj);
static void _vala_game_view_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_game_view_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);

static inline gpointer
game_view_get_instance_private (GameView* self)
{
	return G_STRUCT_MEMBER_P (self, GameView_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 186 "../src/game-view.vala"
	return self ? g_object_ref (self) : NULL;
#line 295 "game-view.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1473 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1473 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1474 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1474 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1474 "glib-2.0.vapi"
	return result;
#line 314 "game-view.c"
}

static void
game_view_set_default_theme (GameView* self,
                             GKeyFile* * key)
{
	GtkSettings* defaults = NULL;
	GtkSettings* _tmp0_;
	GtkSettings* _tmp1_;
	gchar* filename = NULL;
	gboolean _tmp2_ = FALSE;
	GtkSettings* _tmp3_;
	gchar* filepath = NULL;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	GError* _inner_error0_ = NULL;
#line 184 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 184 "../src/game-view.vala"
	g_return_if_fail (*key != NULL);
#line 186 "../src/game-view.vala"
	_tmp0_ = gtk_settings_get_default ();
#line 186 "../src/game-view.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 186 "../src/game-view.vala"
	defaults = _tmp1_;
#line 189 "../src/game-view.vala"
	_tmp3_ = defaults;
#line 189 "../src/game-view.vala"
	if (_tmp3_ != NULL) {
#line 345 "game-view.c"
		GtkSettings* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 189 "../src/game-view.vala"
		_tmp4_ = defaults;
#line 189 "../src/game-view.vala"
		g_object_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_settings_get_type (), GtkSettings), "gtk-theme-name", &_tmp5_, NULL);
#line 189 "../src/game-view.vala"
		_tmp6_ = _tmp5_;
#line 189 "../src/game-view.vala"
		_tmp7_ = _tmp6_;
#line 189 "../src/game-view.vala"
		_tmp2_ = string_contains (_tmp7_, "HighContrast");
#line 189 "../src/game-view.vala"
		_g_free0 (_tmp7_);
#line 362 "game-view.c"
	} else {
#line 189 "../src/game-view.vala"
		_tmp2_ = FALSE;
#line 366 "game-view.c"
	}
#line 189 "../src/game-view.vala"
	if (_tmp2_) {
#line 370 "game-view.c"
		gchar* _tmp8_;
#line 190 "../src/game-view.vala"
		_tmp8_ = g_strdup ("high_contrast.theme");
#line 190 "../src/game-view.vala"
		_g_free0 (filename);
#line 190 "../src/game-view.vala"
		filename = _tmp8_;
#line 378 "game-view.c"
	} else {
		gboolean _tmp9_ = FALSE;
		GtkSettings* _tmp10_;
#line 191 "../src/game-view.vala"
		_tmp10_ = defaults;
#line 191 "../src/game-view.vala"
		if (_tmp10_ != NULL) {
#line 386 "game-view.c"
			gboolean _tmp11_ = FALSE;
			GtkSettings* _tmp12_;
			gboolean _tmp13_;
			gboolean _tmp14_;
#line 191 "../src/game-view.vala"
			_tmp12_ = defaults;
#line 191 "../src/game-view.vala"
			g_object_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_settings_get_type (), GtkSettings), "gtk-application-prefer-dark-theme", &_tmp13_, NULL);
#line 191 "../src/game-view.vala"
			_tmp14_ = _tmp13_;
#line 191 "../src/game-view.vala"
			if (_tmp14_ == TRUE) {
#line 191 "../src/game-view.vala"
				_tmp11_ = TRUE;
#line 401 "game-view.c"
			} else {
				GtkSettings* _tmp15_;
				gchar* _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
#line 192 "../src/game-view.vala"
				_tmp15_ = defaults;
#line 192 "../src/game-view.vala"
				g_object_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, gtk_settings_get_type (), GtkSettings), "gtk-theme-name", &_tmp16_, NULL);
#line 192 "../src/game-view.vala"
				_tmp17_ = _tmp16_;
#line 192 "../src/game-view.vala"
				_tmp18_ = _tmp17_;
#line 192 "../src/game-view.vala"
				_tmp11_ = g_strcmp0 (_tmp18_, "Adwaita-dark") == 0;
#line 192 "../src/game-view.vala"
				_g_free0 (_tmp18_);
#line 419 "game-view.c"
			}
#line 191 "../src/game-view.vala"
			_tmp9_ = _tmp11_;
#line 423 "game-view.c"
		} else {
#line 191 "../src/game-view.vala"
			_tmp9_ = FALSE;
#line 427 "game-view.c"
		}
#line 191 "../src/game-view.vala"
		if (_tmp9_) {
#line 431 "game-view.c"
			gchar* _tmp19_;
#line 193 "../src/game-view.vala"
			_tmp19_ = g_strdup ("adwaita.theme");
#line 193 "../src/game-view.vala"
			_g_free0 (filename);
#line 193 "../src/game-view.vala"
			filename = _tmp19_;
#line 439 "game-view.c"
		} else {
			gchar* _tmp20_;
#line 195 "../src/game-view.vala"
			_tmp20_ = g_strdup ("classic.theme");
#line 195 "../src/game-view.vala"
			_g_free0 (filename);
#line 195 "../src/game-view.vala"
			filename = _tmp20_;
#line 448 "game-view.c"
		}
	}
#line 197 "../src/game-view.vala"
	_tmp21_ = filename;
#line 197 "../src/game-view.vala"
	_tmp22_ = g_build_filename (DATA_DIRECTORY, "themes", "key", _tmp21_, NULL);
#line 197 "../src/game-view.vala"
	filepath = _tmp22_;
#line 457 "game-view.c"
	{
#line 200 "../src/game-view.vala"
		g_key_file_load_from_file (*key, filepath, G_KEY_FILE_NONE, &_inner_error0_);
#line 200 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 463 "game-view.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 198 "../src/game-view.vala"
		g_clear_error (&_inner_error0_);
#line 198 "../src/game-view.vala"
		_inner_error0_ = NULL;
#line 202 "../src/game-view.vala"
		g_assert_not_reached ();
#line 476 "game-view.c"
	}
	__finally0:
#line 198 "../src/game-view.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 198 "../src/game-view.vala"
		_g_free0 (filepath);
#line 198 "../src/game-view.vala"
		_g_free0 (filename);
#line 198 "../src/game-view.vala"
		_g_object_unref0 (defaults);
#line 198 "../src/game-view.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 198 "../src/game-view.vala"
		g_clear_error (&_inner_error0_);
#line 198 "../src/game-view.vala"
		return;
#line 493 "game-view.c"
	}
#line 184 "../src/game-view.vala"
	_g_free0 (filepath);
#line 184 "../src/game-view.vala"
	_g_free0 (filename);
#line 184 "../src/game-view.vala"
	_g_object_unref0 (defaults);
#line 501 "game-view.c"
}

static void
game_view_load_theme (GameView* self,
                      GKeyFile* key)
{
	GError* _inner_error0_ = NULL;
#line 205 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 205 "../src/game-view.vala"
	g_return_if_fail (key != NULL);
#line 513 "game-view.c"
	{
		gchar* svg_path = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
		gboolean _tmp9_;
		gdouble _tmp12_ = 0.0;
		gdouble _tmp13_ = 0.0;
		gdouble _tmp14_ = 0.0;
		gint _tmp15_ = 0;
		gdouble _tmp16_ = 0.0;
		gdouble _tmp17_ = 0.0;
		gdouble _tmp18_ = 0.0;
		gint _tmp19_ = 0;
		gdouble _tmp20_ = 0.0;
		gdouble _tmp21_ = 0.0;
		gdouble _tmp22_ = 0.0;
		gint _tmp23_ = 0;
		gdouble _tmp24_ = 0.0;
		gdouble _tmp25_ = 0.0;
		gdouble _tmp26_ = 0.0;
		gint _tmp27_ = 0;
		gdouble _tmp28_ = 0.0;
		gdouble _tmp29_ = 0.0;
		gdouble _tmp30_ = 0.0;
		gdouble _tmp31_ = 0.0;
		gchar* _tmp32_ = NULL;
		gchar* _tmp33_;
		gchar* _tmp34_ = NULL;
		gchar* _tmp35_;
#line 209 "../src/game-view.vala"
		_tmp0_ = g_build_filename (DATA_DIRECTORY, "themes", "svg", NULL);
#line 209 "../src/game-view.vala"
		svg_path = _tmp0_;
#line 210 "../src/game-view.vala"
		_tmp2_ = g_key_file_get_string (key, "Pieces", "File", &_inner_error0_);
#line 210 "../src/game-view.vala"
		_tmp1_ = _tmp2_;
#line 210 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 210 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 210 "../src/game-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 564 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 210 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 210 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 210 "../src/game-view.vala"
			g_clear_error (&_inner_error0_);
#line 210 "../src/game-view.vala"
			return;
#line 575 "game-view.c"
		}
#line 210 "../src/game-view.vala"
		_tmp3_ = svg_path;
#line 210 "../src/game-view.vala"
		_tmp4_ = g_build_filename (_tmp3_, _tmp1_, NULL);
#line 210 "../src/game-view.vala"
		_g_free0 (self->priv->pieces_file);
#line 210 "../src/game-view.vala"
		self->priv->pieces_file = _tmp4_;
#line 211 "../src/game-view.vala"
		_tmp5_ = self->priv->pieces_file;
#line 211 "../src/game-view.vala"
		_tmp6_ = g_path_get_dirname (_tmp5_);
#line 211 "../src/game-view.vala"
		_tmp7_ = _tmp6_;
#line 211 "../src/game-view.vala"
		_tmp8_ = svg_path;
#line 211 "../src/game-view.vala"
		_tmp9_ = g_strcmp0 (_tmp7_, _tmp8_) != 0;
#line 211 "../src/game-view.vala"
		_g_free0 (_tmp7_);
#line 211 "../src/game-view.vala"
		if (_tmp9_) {
#line 599 "game-view.c"
			const gchar* _tmp10_;
			gchar* _tmp11_;
#line 212 "../src/game-view.vala"
			_tmp10_ = svg_path;
#line 212 "../src/game-view.vala"
			_tmp11_ = g_build_filename (_tmp10_, "black_and_white.svg", NULL);
#line 212 "../src/game-view.vala"
			_g_free0 (self->priv->pieces_file);
#line 212 "../src/game-view.vala"
			self->priv->pieces_file = _tmp11_;
#line 610 "game-view.c"
		}
#line 214 "../src/game-view.vala"
		_tmp12_ = g_key_file_get_double (key, "Background", "Red", &_inner_error0_);
#line 214 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 214 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 214 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 214 "../src/game-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 622 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 214 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 214 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 214 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 214 "../src/game-view.vala"
			g_clear_error (&_inner_error0_);
#line 214 "../src/game-view.vala"
			return;
#line 635 "game-view.c"
		}
#line 214 "../src/game-view.vala"
		self->priv->background_red = _tmp12_;
#line 215 "../src/game-view.vala"
		_tmp13_ = g_key_file_get_double (key, "Background", "Green", &_inner_error0_);
#line 215 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 215 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 215 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 215 "../src/game-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 649 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 215 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 215 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 215 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 215 "../src/game-view.vala"
			g_clear_error (&_inner_error0_);
#line 215 "../src/game-view.vala"
			return;
#line 662 "game-view.c"
		}
#line 215 "../src/game-view.vala"
		self->priv->background_green = _tmp13_;
#line 216 "../src/game-view.vala"
		_tmp14_ = g_key_file_get_double (key, "Background", "Blue", &_inner_error0_);
#line 216 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 216 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 216 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 216 "../src/game-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 676 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 216 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 216 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 216 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 216 "../src/game-view.vala"
			g_clear_error (&_inner_error0_);
#line 216 "../src/game-view.vala"
			return;
#line 689 "game-view.c"
		}
#line 216 "../src/game-view.vala"
		self->priv->background_blue = _tmp14_;
#line 217 "../src/game-view.vala"
		_tmp15_ = g_key_file_get_integer (key, "Background", "Radius", &_inner_error0_);
#line 217 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 217 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 217 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 217 "../src/game-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 703 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 217 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 217 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 217 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 217 "../src/game-view.vala"
			g_clear_error (&_inner_error0_);
#line 217 "../src/game-view.vala"
			return;
#line 716 "game-view.c"
		}
#line 217 "../src/game-view.vala"
		self->priv->background_radius = _tmp15_;
#line 219 "../src/game-view.vala"
		_tmp16_ = g_key_file_get_double (key, "Mark", "Red", &_inner_error0_);
#line 219 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 219 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 219 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 219 "../src/game-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 730 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 219 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 219 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 219 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 219 "../src/game-view.vala"
			g_clear_error (&_inner_error0_);
#line 219 "../src/game-view.vala"
			return;
#line 743 "game-view.c"
		}
#line 219 "../src/game-view.vala"
		self->priv->mark_red = _tmp16_;
#line 220 "../src/game-view.vala"
		_tmp17_ = g_key_file_get_double (key, "Mark", "Green", &_inner_error0_);
#line 220 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 220 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 220 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 220 "../src/game-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 757 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 220 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 220 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 220 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 220 "../src/game-view.vala"
			g_clear_error (&_inner_error0_);
#line 220 "../src/game-view.vala"
			return;
#line 770 "game-view.c"
		}
#line 220 "../src/game-view.vala"
		self->priv->mark_green = _tmp17_;
#line 221 "../src/game-view.vala"
		_tmp18_ = g_key_file_get_double (key, "Mark", "Blue", &_inner_error0_);
#line 221 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 221 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 221 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 221 "../src/game-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 784 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 221 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 221 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 221 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 221 "../src/game-view.vala"
			g_clear_error (&_inner_error0_);
#line 221 "../src/game-view.vala"
			return;
#line 797 "game-view.c"
		}
#line 221 "../src/game-view.vala"
		self->priv->mark_blue = _tmp18_;
#line 222 "../src/game-view.vala"
		_tmp19_ = g_key_file_get_integer (key, "Mark", "Width", &_inner_error0_);
#line 222 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 222 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 222 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 222 "../src/game-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 811 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 222 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 222 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 222 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 222 "../src/game-view.vala"
			g_clear_error (&_inner_error0_);
#line 222 "../src/game-view.vala"
			return;
#line 824 "game-view.c"
		}
#line 222 "../src/game-view.vala"
		self->priv->mark_width = _tmp19_;
#line 224 "../src/game-view.vala"
		_tmp20_ = g_key_file_get_double (key, "Border", "Red", &_inner_error0_);
#line 224 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 224 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 224 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 224 "../src/game-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 838 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 224 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 224 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 224 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 224 "../src/game-view.vala"
			g_clear_error (&_inner_error0_);
#line 224 "../src/game-view.vala"
			return;
#line 851 "game-view.c"
		}
#line 224 "../src/game-view.vala"
		self->priv->border_red = _tmp20_;
#line 225 "../src/game-view.vala"
		_tmp21_ = g_key_file_get_double (key, "Border", "Green", &_inner_error0_);
#line 225 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 225 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 225 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 225 "../src/game-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 865 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 225 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 225 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 225 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 225 "../src/game-view.vala"
			g_clear_error (&_inner_error0_);
#line 225 "../src/game-view.vala"
			return;
#line 878 "game-view.c"
		}
#line 225 "../src/game-view.vala"
		self->priv->border_green = _tmp21_;
#line 226 "../src/game-view.vala"
		_tmp22_ = g_key_file_get_double (key, "Border", "Blue", &_inner_error0_);
#line 226 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 226 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 226 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 226 "../src/game-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 892 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 226 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 226 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 226 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 226 "../src/game-view.vala"
			g_clear_error (&_inner_error0_);
#line 226 "../src/game-view.vala"
			return;
#line 905 "game-view.c"
		}
#line 226 "../src/game-view.vala"
		self->priv->border_blue = _tmp22_;
#line 227 "../src/game-view.vala"
		_tmp23_ = g_key_file_get_integer (key, "Border", "Width", &_inner_error0_);
#line 227 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 227 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 227 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 227 "../src/game-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 919 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 227 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 227 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 227 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 227 "../src/game-view.vala"
			g_clear_error (&_inner_error0_);
#line 227 "../src/game-view.vala"
			return;
#line 932 "game-view.c"
		}
#line 227 "../src/game-view.vala"
		self->priv->border_width = _tmp23_;
#line 229 "../src/game-view.vala"
		_tmp24_ = g_key_file_get_double (key, "Spacing", "Red", &_inner_error0_);
#line 229 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 229 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 229 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 229 "../src/game-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 946 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 229 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 229 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 229 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 229 "../src/game-view.vala"
			g_clear_error (&_inner_error0_);
#line 229 "../src/game-view.vala"
			return;
#line 959 "game-view.c"
		}
#line 229 "../src/game-view.vala"
		self->priv->spacing_red = _tmp24_;
#line 230 "../src/game-view.vala"
		_tmp25_ = g_key_file_get_double (key, "Spacing", "Green", &_inner_error0_);
#line 230 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 230 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 230 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 230 "../src/game-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 973 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 230 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 230 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 230 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 230 "../src/game-view.vala"
			g_clear_error (&_inner_error0_);
#line 230 "../src/game-view.vala"
			return;
#line 986 "game-view.c"
		}
#line 230 "../src/game-view.vala"
		self->priv->spacing_green = _tmp25_;
#line 231 "../src/game-view.vala"
		_tmp26_ = g_key_file_get_double (key, "Spacing", "Blue", &_inner_error0_);
#line 231 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 231 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 231 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 231 "../src/game-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1000 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 231 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 231 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 231 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 231 "../src/game-view.vala"
			g_clear_error (&_inner_error0_);
#line 231 "../src/game-view.vala"
			return;
#line 1013 "game-view.c"
		}
#line 231 "../src/game-view.vala"
		self->priv->spacing_blue = _tmp26_;
#line 232 "../src/game-view.vala"
		_tmp27_ = g_key_file_get_integer (key, "Spacing", "Width", &_inner_error0_);
#line 232 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 232 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 232 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 232 "../src/game-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1027 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 232 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 232 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 232 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 232 "../src/game-view.vala"
			g_clear_error (&_inner_error0_);
#line 232 "../src/game-view.vala"
			return;
#line 1040 "game-view.c"
		}
#line 232 "../src/game-view.vala"
		self->priv->spacing_width = _tmp27_;
#line 234 "../src/game-view.vala"
		_tmp28_ = g_key_file_get_double (key, "Highlight", "Red", &_inner_error0_);
#line 234 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 234 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 234 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 234 "../src/game-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1054 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 234 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 234 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 234 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 234 "../src/game-view.vala"
			g_clear_error (&_inner_error0_);
#line 234 "../src/game-view.vala"
			return;
#line 1067 "game-view.c"
		}
#line 234 "../src/game-view.vala"
		self->priv->highlight_red = _tmp28_;
#line 235 "../src/game-view.vala"
		_tmp29_ = g_key_file_get_double (key, "Highlight", "Green", &_inner_error0_);
#line 235 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 235 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 235 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 235 "../src/game-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1081 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 235 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 235 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 235 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 235 "../src/game-view.vala"
			g_clear_error (&_inner_error0_);
#line 235 "../src/game-view.vala"
			return;
#line 1094 "game-view.c"
		}
#line 235 "../src/game-view.vala"
		self->priv->highlight_green = _tmp29_;
#line 236 "../src/game-view.vala"
		_tmp30_ = g_key_file_get_double (key, "Highlight", "Blue", &_inner_error0_);
#line 236 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 236 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 236 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 236 "../src/game-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1108 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 236 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 236 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 236 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 236 "../src/game-view.vala"
			g_clear_error (&_inner_error0_);
#line 236 "../src/game-view.vala"
			return;
#line 1121 "game-view.c"
		}
#line 236 "../src/game-view.vala"
		self->priv->highlight_blue = _tmp30_;
#line 237 "../src/game-view.vala"
		_tmp31_ = g_key_file_get_double (key, "Highlight", "Alpha", &_inner_error0_);
#line 237 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 237 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 237 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 237 "../src/game-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1135 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 237 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 237 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 237 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 237 "../src/game-view.vala"
			g_clear_error (&_inner_error0_);
#line 237 "../src/game-view.vala"
			return;
#line 1148 "game-view.c"
		}
#line 237 "../src/game-view.vala"
		self->priv->highlight_alpha = _tmp31_;
#line 241 "../src/game-view.vala"
		_tmp33_ = g_key_file_get_string (key, "Sound", "Flip", &_inner_error0_);
#line 241 "../src/game-view.vala"
		_tmp32_ = _tmp33_;
#line 241 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 241 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 241 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 241 "../src/game-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1164 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 241 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 241 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 241 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 241 "../src/game-view.vala"
			g_clear_error (&_inner_error0_);
#line 241 "../src/game-view.vala"
			return;
#line 1177 "game-view.c"
		}
#line 241 "../src/game-view.vala"
		game_view_set_sound_flip (self, _tmp32_);
#line 242 "../src/game-view.vala"
		_tmp35_ = g_key_file_get_string (key, "Sound", "GameOver", &_inner_error0_);
#line 242 "../src/game-view.vala"
		_tmp34_ = _tmp35_;
#line 242 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 242 "../src/game-view.vala"
			_g_free0 (_tmp32_);
#line 242 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 242 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 242 "../src/game-view.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1195 "game-view.c"
				goto __catch1_g_key_file_error;
			}
#line 242 "../src/game-view.vala"
			_g_free0 (_tmp32_);
#line 242 "../src/game-view.vala"
			_g_free0 (_tmp1_);
#line 242 "../src/game-view.vala"
			_g_free0 (svg_path);
#line 242 "../src/game-view.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 242 "../src/game-view.vala"
			g_clear_error (&_inner_error0_);
#line 242 "../src/game-view.vala"
			return;
#line 1210 "game-view.c"
		}
#line 242 "../src/game-view.vala"
		game_view_set_sound_gameover (self, _tmp34_);
#line 207 "../src/game-view.vala"
		_g_free0 (_tmp34_);
#line 207 "../src/game-view.vala"
		_g_free0 (_tmp32_);
#line 207 "../src/game-view.vala"
		_g_free0 (_tmp1_);
#line 207 "../src/game-view.vala"
		_g_free0 (svg_path);
#line 1222 "game-view.c"
	}
	goto __finally1;
	__catch1_g_key_file_error:
	{
		GError* e = NULL;
		GError* _tmp36_;
		const gchar* _tmp37_;
#line 207 "../src/game-view.vala"
		e = _inner_error0_;
#line 207 "../src/game-view.vala"
		_inner_error0_ = NULL;
#line 246 "../src/game-view.vala"
		_tmp36_ = e;
#line 246 "../src/game-view.vala"
		_tmp37_ = _tmp36_->message;
#line 246 "../src/game-view.vala"
		g_warning ("game-view.vala:246: Errors when loading theme: %s", _tmp37_);
#line 207 "../src/game-view.vala"
		_g_error_free0 (e);
#line 1242 "game-view.c"
	}
	__finally1:
#line 207 "../src/game-view.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 207 "../src/game-view.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 207 "../src/game-view.vala"
		g_clear_error (&_inner_error0_);
#line 207 "../src/game-view.vala"
		return;
#line 1253 "game-view.c"
	}
}

static void
game_view_calculate (GameView* self)
{
	gint size = 0;
#line 258 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 258 "../src/game-view.vala"
	_vala_return_if_fail (self->priv->game_is_set, "game_is_set");
#line 261 "../src/game-view.vala"
	size = MIN (gtk_widget_get_allocated_width ((GtkWidget*) self), gtk_widget_get_allocated_height ((GtkWidget*) self));
#line 262 "../src/game-view.vala"
	self->priv->paving_size = ((size - (2 * self->priv->border_width)) + self->priv->spacing_width) / self->priv->game_size;
#line 263 "../src/game-view.vala"
	self->priv->tile_size = self->priv->paving_size - self->priv->spacing_width;
#line 265 "../src/game-view.vala"
	self->priv->board_size = (self->priv->paving_size * self->priv->game_size) - self->priv->spacing_width;
#line 1273 "game-view.c"
}

static gboolean
game_view_real_draw (GtkWidget* base,
                     cairo_t* cr)
{
	GameView * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	cairo_pattern_t* _tmp1_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
#line 268 "../src/game-view.vala"
	self = (GameView*) base;
#line 268 "../src/game-view.vala"
	g_return_val_if_fail (cr != NULL, FALSE);
#line 270 "../src/game-view.vala"
	if (!self->priv->game_is_set) {
#line 271 "../src/game-view.vala"
		result = FALSE;
#line 271 "../src/game-view.vala"
		return result;
#line 1298 "game-view.c"
	}
#line 273 "../src/game-view.vala"
	game_view_calculate (self);
#line 275 "../src/game-view.vala"
	_tmp1_ = self->priv->tiles_pattern;
#line 275 "../src/game-view.vala"
	if (_tmp1_ == NULL) {
#line 275 "../src/game-view.vala"
		_tmp0_ = TRUE;
#line 1308 "game-view.c"
	} else {
#line 275 "../src/game-view.vala"
		_tmp0_ = self->priv->render_size != ((guint) self->priv->tile_size);
#line 1312 "game-view.c"
	}
#line 275 "../src/game-view.vala"
	if (_tmp0_) {
#line 1316 "game-view.c"
		cairo_surface_t* surface = NULL;
		cairo_surface_t* _tmp2_;
		cairo_surface_t* _tmp3_;
		cairo_t* c = NULL;
		cairo_surface_t* _tmp4_;
		cairo_t* _tmp5_;
		cairo_t* _tmp6_;
		cairo_surface_t* _tmp7_;
		cairo_pattern_t* _tmp8_;
#line 277 "../src/game-view.vala"
		self->priv->render_size = (guint) self->priv->tile_size;
#line 278 "../src/game-view.vala"
		_tmp2_ = cairo_get_target (cr);
#line 278 "../src/game-view.vala"
		_tmp3_ = cairo_surface_create_similar (_tmp2_, CAIRO_CONTENT_COLOR_ALPHA, self->priv->tile_size * 8, self->priv->tile_size * 4);
#line 278 "../src/game-view.vala"
		surface = _tmp3_;
#line 279 "../src/game-view.vala"
		_tmp4_ = surface;
#line 279 "../src/game-view.vala"
		_tmp5_ = cairo_create (_tmp4_);
#line 279 "../src/game-view.vala"
		c = _tmp5_;
#line 280 "../src/game-view.vala"
		_tmp6_ = c;
#line 280 "../src/game-view.vala"
		game_view_load_image (self, _tmp6_, self->priv->tile_size * 8, self->priv->tile_size * 4);
#line 281 "../src/game-view.vala"
		_tmp7_ = surface;
#line 281 "../src/game-view.vala"
		_tmp8_ = cairo_pattern_create_for_surface (_tmp7_);
#line 281 "../src/game-view.vala"
		_cairo_pattern_destroy0 (self->priv->tiles_pattern);
#line 281 "../src/game-view.vala"
		self->priv->tiles_pattern = _tmp8_;
#line 275 "../src/game-view.vala"
		_cairo_destroy0 (c);
#line 275 "../src/game-view.vala"
		_cairo_surface_destroy0 (surface);
#line 1356 "game-view.c"
	}
#line 284 "../src/game-view.vala"
	_tmp9_ = game_view_get_board_x (self);
#line 284 "../src/game-view.vala"
	_tmp10_ = _tmp9_;
#line 284 "../src/game-view.vala"
	_tmp11_ = game_view_get_board_y (self);
#line 284 "../src/game-view.vala"
	_tmp12_ = _tmp11_;
#line 284 "../src/game-view.vala"
	cairo_translate (cr, (gdouble) _tmp10_, (gdouble) _tmp12_);
#line 287 "../src/game-view.vala"
	cairo_set_source_rgba (cr, self->priv->spacing_red, self->priv->spacing_green, self->priv->spacing_blue, 1.0);
#line 288 "../src/game-view.vala"
	cairo_rectangle (cr, (-self->priv->border_width) / 2.0, (-self->priv->border_width) / 2.0, (gdouble) (self->priv->board_size + self->priv->border_width), (gdouble) (self->priv->board_size + self->priv->border_width));
#line 289 "../src/game-view.vala"
	cairo_fill_preserve (cr);
#line 290 "../src/game-view.vala"
	cairo_set_source_rgba (cr, self->priv->border_red, self->priv->border_green, self->priv->border_blue, 1.0);
#line 291 "../src/game-view.vala"
	cairo_set_line_width (cr, (gdouble) self->priv->border_width);
#line 292 "../src/game-view.vala"
	cairo_stroke (cr);
#line 1380 "game-view.c"
	{
		guint8 x = 0U;
#line 295 "../src/game-view.vala"
		x = (guint8) 0;
#line 1385 "game-view.c"
		{
			gboolean _tmp13_ = FALSE;
#line 295 "../src/game-view.vala"
			_tmp13_ = TRUE;
#line 295 "../src/game-view.vala"
			while (TRUE) {
#line 295 "../src/game-view.vala"
				if (!_tmp13_) {
#line 1394 "game-view.c"
					guint8 _tmp14_;
#line 295 "../src/game-view.vala"
					_tmp14_ = x;
#line 295 "../src/game-view.vala"
					x = _tmp14_ + 1;
#line 1400 "game-view.c"
				}
#line 295 "../src/game-view.vala"
				_tmp13_ = FALSE;
#line 295 "../src/game-view.vala"
				if (!(x < self->priv->game_size)) {
#line 295 "../src/game-view.vala"
					break;
#line 1408 "game-view.c"
				}
				{
					guint8 y = 0U;
#line 297 "../src/game-view.vala"
					y = (guint8) 0;
#line 1414 "game-view.c"
					{
						gboolean _tmp15_ = FALSE;
#line 297 "../src/game-view.vala"
						_tmp15_ = TRUE;
#line 297 "../src/game-view.vala"
						while (TRUE) {
#line 1421 "game-view.c"
							gint tile_x = 0;
							gint tile_y = 0;
							gboolean _tmp17_ = FALSE;
							gboolean _tmp18_ = FALSE;
							gboolean _tmp19_ = FALSE;
							gint* _tmp32_;
							gint _tmp32__length1;
							gint _tmp32__length2;
							gint _tmp33_;
							gint texture_x = 0;
							gint* _tmp34_;
							gint _tmp34__length1;
							gint _tmp34__length2;
							gint _tmp35_;
							gint texture_y = 0;
							gint* _tmp36_;
							gint _tmp36__length1;
							gint _tmp36__length2;
							gint _tmp37_;
							cairo_matrix_t matrix = {0};
							cairo_pattern_t* _tmp38_;
							cairo_matrix_t _tmp39_;
							cairo_pattern_t* _tmp40_;
#line 297 "../src/game-view.vala"
							if (!_tmp15_) {
#line 1447 "game-view.c"
								guint8 _tmp16_;
#line 297 "../src/game-view.vala"
								_tmp16_ = y;
#line 297 "../src/game-view.vala"
								y = _tmp16_ + 1;
#line 1453 "game-view.c"
							}
#line 297 "../src/game-view.vala"
							_tmp15_ = FALSE;
#line 297 "../src/game-view.vala"
							if (!(y < self->priv->game_size)) {
#line 297 "../src/game-view.vala"
								break;
#line 1461 "game-view.c"
							}
#line 299 "../src/game-view.vala"
							tile_x = ((gint) x) * self->priv->paving_size;
#line 300 "../src/game-view.vala"
							tile_y = ((gint) y) * self->priv->paving_size;
#line 303 "../src/game-view.vala"
							cairo_set_source_rgba (cr, self->priv->background_red, self->priv->background_green, self->priv->background_blue, 1.0);
#line 304 "../src/game-view.vala"
							game_view_rounded_square (self, cr, (gdouble) tile_x, (gdouble) tile_y, self->priv->tile_size, (gdouble) 0, (gdouble) self->priv->background_radius);
#line 305 "../src/game-view.vala"
							cairo_fill (cr);
#line 307 "../src/game-view.vala"
							if (self->priv->highlight_x == x) {
#line 307 "../src/game-view.vala"
								_tmp19_ = self->priv->highlight_y == y;
#line 1477 "game-view.c"
							} else {
#line 307 "../src/game-view.vala"
								_tmp19_ = FALSE;
#line 1481 "game-view.c"
							}
#line 307 "../src/game-view.vala"
							if (_tmp19_) {
#line 1485 "game-view.c"
								gboolean _tmp20_ = FALSE;
#line 308 "../src/game-view.vala"
								if (self->priv->show_highlight) {
#line 308 "../src/game-view.vala"
									_tmp20_ = TRUE;
#line 1491 "game-view.c"
								} else {
#line 308 "../src/game-view.vala"
									_tmp20_ = ((gint) self->priv->highlight_state) != 0;
#line 1495 "game-view.c"
								}
#line 308 "../src/game-view.vala"
								_tmp18_ = _tmp20_;
#line 1499 "game-view.c"
							} else {
#line 307 "../src/game-view.vala"
								_tmp18_ = FALSE;
#line 1503 "game-view.c"
							}
#line 307 "../src/game-view.vala"
							if (_tmp18_) {
#line 1507 "game-view.c"
								Game* _tmp21_;
								Game* _tmp22_;
								gboolean _tmp23_;
								gboolean _tmp24_;
#line 309 "../src/game-view.vala"
								_tmp21_ = game_view_get_game (self);
#line 309 "../src/game-view.vala"
								_tmp22_ = _tmp21_;
#line 309 "../src/game-view.vala"
								_tmp23_ = game_get_is_complete (_tmp22_);
#line 309 "../src/game-view.vala"
								_tmp24_ = _tmp23_;
#line 309 "../src/game-view.vala"
								_tmp17_ = !_tmp24_;
#line 1522 "game-view.c"
							} else {
#line 307 "../src/game-view.vala"
								_tmp17_ = FALSE;
#line 1526 "game-view.c"
							}
#line 307 "../src/game-view.vala"
							if (_tmp17_) {
#line 1530 "game-view.c"
								gboolean _tmp25_ = FALSE;
#line 312 "../src/game-view.vala"
								if (self->priv->show_highlight) {
#line 312 "../src/game-view.vala"
									_tmp25_ = self->priv->highlight_state != GAME_VIEW_HIGHLIGHT_MAX;
#line 1536 "game-view.c"
								} else {
#line 312 "../src/game-view.vala"
									_tmp25_ = FALSE;
#line 1540 "game-view.c"
								}
#line 312 "../src/game-view.vala"
								if (_tmp25_) {
#line 1544 "game-view.c"
									guint8 _tmp26_;
									gint _tmp27_;
									gint _tmp28_;
									gint _tmp29_;
									gint _tmp30_;
#line 314 "../src/game-view.vala"
									_tmp26_ = self->priv->highlight_state;
#line 314 "../src/game-view.vala"
									self->priv->highlight_state = _tmp26_ + 1;
#line 315 "../src/game-view.vala"
									_tmp27_ = game_view_get_board_x (self);
#line 315 "../src/game-view.vala"
									_tmp28_ = _tmp27_;
#line 315 "../src/game-view.vala"
									_tmp29_ = game_view_get_board_y (self);
#line 315 "../src/game-view.vala"
									_tmp30_ = _tmp29_;
#line 315 "../src/game-view.vala"
									gtk_widget_queue_draw_area ((GtkWidget*) self, _tmp28_ + tile_x, _tmp30_ + tile_y, self->priv->tile_size, self->priv->tile_size);
#line 1564 "game-view.c"
								} else {
									gboolean _tmp31_ = FALSE;
#line 317 "../src/game-view.vala"
									if (!self->priv->show_highlight) {
#line 317 "../src/game-view.vala"
										_tmp31_ = ((gint) self->priv->highlight_state) != 0;
#line 1571 "game-view.c"
									} else {
#line 317 "../src/game-view.vala"
										_tmp31_ = FALSE;
#line 1575 "game-view.c"
									}
#line 317 "../src/game-view.vala"
									if (_tmp31_) {
#line 318 "../src/game-view.vala"
										self->priv->highlight_state = (guint8) 0;
#line 1581 "game-view.c"
									}
								}
#line 321 "../src/game-view.vala"
								cairo_set_source_rgba (cr, self->priv->highlight_red, self->priv->highlight_green, self->priv->highlight_blue, self->priv->highlight_alpha);
#line 322 "../src/game-view.vala"
								game_view_rounded_square (self, cr, (gdouble) (tile_x + ((self->priv->tile_size * (GAME_VIEW_HIGHLIGHT_MAX - self->priv->highlight_state)) / (2 * GAME_VIEW_HIGHLIGHT_MAX))), (gdouble) (tile_y + ((self->priv->tile_size * (GAME_VIEW_HIGHLIGHT_MAX - self->priv->highlight_state)) / (2 * GAME_VIEW_HIGHLIGHT_MAX))), (self->priv->tile_size * self->priv->highlight_state) / GAME_VIEW_HIGHLIGHT_MAX, (gdouble) 0, (gdouble) self->priv->background_radius);
#line 329 "../src/game-view.vala"
								cairo_fill (cr);
#line 1590 "game-view.c"
							}
#line 333 "../src/game-view.vala"
							_tmp32_ = self->priv->pixmaps;
#line 333 "../src/game-view.vala"
							_tmp32__length1 = self->priv->pixmaps_length1;
#line 333 "../src/game-view.vala"
							_tmp32__length2 = self->priv->pixmaps_length2;
#line 333 "../src/game-view.vala"
							_tmp33_ = _tmp32_[(x * _tmp32__length2) + y];
#line 333 "../src/game-view.vala"
							if (_tmp33_ == 0) {
#line 334 "../src/game-view.vala"
								continue;
#line 1604 "game-view.c"
							}
#line 336 "../src/game-view.vala"
							_tmp34_ = self->priv->pixmaps;
#line 336 "../src/game-view.vala"
							_tmp34__length1 = self->priv->pixmaps_length1;
#line 336 "../src/game-view.vala"
							_tmp34__length2 = self->priv->pixmaps_length2;
#line 336 "../src/game-view.vala"
							_tmp35_ = _tmp34_[(x * _tmp34__length2) + y];
#line 336 "../src/game-view.vala"
							texture_x = (_tmp35_ % 8) * self->priv->tile_size;
#line 337 "../src/game-view.vala"
							_tmp36_ = self->priv->pixmaps;
#line 337 "../src/game-view.vala"
							_tmp36__length1 = self->priv->pixmaps_length1;
#line 337 "../src/game-view.vala"
							_tmp36__length2 = self->priv->pixmaps_length2;
#line 337 "../src/game-view.vala"
							_tmp37_ = _tmp36_[(x * _tmp36__length2) + y];
#line 337 "../src/game-view.vala"
							texture_y = (_tmp37_ / 8) * self->priv->tile_size;
#line 339 "../src/game-view.vala"
							cairo_matrix_init_identity (&matrix);
#line 340 "../src/game-view.vala"
							cairo_matrix_translate (&matrix, (gdouble) (texture_x - tile_x), (gdouble) (texture_y - tile_y));
#line 341 "../src/game-view.vala"
							_tmp38_ = self->priv->tiles_pattern;
#line 341 "../src/game-view.vala"
							_tmp39_ = matrix;
#line 341 "../src/game-view.vala"
							cairo_pattern_set_matrix ((cairo_pattern_t*) _tmp38_, &_tmp39_);
#line 342 "../src/game-view.vala"
							_tmp40_ = self->priv->tiles_pattern;
#line 342 "../src/game-view.vala"
							cairo_set_source (cr, (cairo_pattern_t*) _tmp40_);
#line 343 "../src/game-view.vala"
							cairo_rectangle (cr, (gdouble) tile_x, (gdouble) tile_y, (gdouble) self->priv->tile_size, (gdouble) self->priv->tile_size);
#line 344 "../src/game-view.vala"
							cairo_fill (cr);
#line 1644 "game-view.c"
						}
					}
				}
			}
		}
	}
#line 347 "../src/game-view.vala"
	result = FALSE;
#line 347 "../src/game-view.vala"
	return result;
#line 1655 "game-view.c"
}

static void
game_view_rounded_square (GameView* self,
                          cairo_t* cr,
                          gdouble x,
                          gdouble y,
                          gint size,
                          gdouble width,
                          gdouble radius_percent)
{
	gdouble radius_border = 0.0;
	gdouble radius_arc = 0.0;
	gdouble x1 = 0.0;
	gdouble y1 = 0.0;
	gdouble x2 = 0.0;
	gdouble y2 = 0.0;
#line 351 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 351 "../src/game-view.vala"
	g_return_if_fail (cr != NULL);
#line 353 "../src/game-view.vala"
	if (radius_percent <= ((gdouble) 0)) {
#line 355 "../src/game-view.vala"
		cairo_rectangle (cr, x + (width / 2.0), y + (width / 2.0), size + width, size + width);
#line 356 "../src/game-view.vala"
		return;
#line 1683 "game-view.c"
	}
#line 359 "../src/game-view.vala"
	if (radius_percent > ((gdouble) 50)) {
#line 360 "../src/game-view.vala"
		radius_percent = (gdouble) 50;
#line 1689 "game-view.c"
	}
#line 361 "../src/game-view.vala"
	radius_border = (radius_percent * size) / 100.0;
#line 362 "../src/game-view.vala"
	radius_arc = radius_border - (width / 2.0);
#line 363 "../src/game-view.vala"
	x1 = x + radius_border;
#line 364 "../src/game-view.vala"
	y1 = y + radius_border;
#line 365 "../src/game-view.vala"
	x2 = (x + size) - radius_border;
#line 366 "../src/game-view.vala"
	y2 = (y + size) - radius_border;
#line 368 "../src/game-view.vala"
	cairo_arc (cr, x1, y1, radius_arc, G_PI, -GAME_VIEW_HALF_PI);
#line 369 "../src/game-view.vala"
	cairo_arc (cr, x2, y1, radius_arc, -GAME_VIEW_HALF_PI, (gdouble) 0);
#line 370 "../src/game-view.vala"
	cairo_arc (cr, x2, y2, radius_arc, (gdouble) 0, GAME_VIEW_HALF_PI);
#line 371 "../src/game-view.vala"
	cairo_arc (cr, x1, y2, radius_arc, GAME_VIEW_HALF_PI, G_PI);
#line 372 "../src/game-view.vala"
	cairo_arc (cr, x1, y1, radius_arc, G_PI, -GAME_VIEW_HALF_PI);
#line 1713 "game-view.c"
}

static void
game_view_load_image (GameView* self,
                      cairo_t* c,
                      gint width,
                      gint height)
{
	GError* _inner_error0_ = NULL;
#line 375 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 375 "../src/game-view.vala"
	g_return_if_fail (c != NULL);
#line 1727 "game-view.c"
	{
		RsvgHandle* h = NULL;
		const gchar* _tmp0_;
		RsvgHandle* _tmp1_;
		cairo_matrix_t m = {0};
		gint _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		cairo_matrix_t _tmp6_;
#line 379 "../src/game-view.vala"
		_tmp0_ = self->priv->pieces_file;
#line 379 "../src/game-view.vala"
		_tmp1_ = rsvg_handle_new_from_file (_tmp0_, &_inner_error0_);
#line 379 "../src/game-view.vala"
		h = _tmp1_;
#line 379 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1746 "game-view.c"
			goto __catch2_g_error;
		}
#line 381 "../src/game-view.vala"
		cairo_matrix_init_identity (&m);
#line 382 "../src/game-view.vala"
		g_object_get (h, "width", &_tmp2_, NULL);
#line 382 "../src/game-view.vala"
		_tmp3_ = _tmp2_;
#line 382 "../src/game-view.vala"
		g_object_get (h, "height", &_tmp4_, NULL);
#line 382 "../src/game-view.vala"
		_tmp5_ = _tmp4_;
#line 382 "../src/game-view.vala"
		cairo_matrix_scale (&m, ((gdouble) width) / _tmp3_, ((gdouble) height) / _tmp5_);
#line 383 "../src/game-view.vala"
		_tmp6_ = m;
#line 383 "../src/game-view.vala"
		cairo_set_matrix (c, &_tmp6_);
#line 384 "../src/game-view.vala"
		rsvg_handle_render_cairo (h, c);
#line 386 "../src/game-view.vala"
		_g_object_unref0 (h);
#line 386 "../src/game-view.vala"
		return;
#line 1771 "game-view.c"
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* e = NULL;
#line 377 "../src/game-view.vala"
		e = _inner_error0_;
#line 377 "../src/game-view.vala"
		_inner_error0_ = NULL;
#line 377 "../src/game-view.vala"
		_g_error_free0 (e);
#line 1783 "game-view.c"
	}
	__finally2:
#line 377 "../src/game-view.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 377 "../src/game-view.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 377 "../src/game-view.vala"
		g_clear_error (&_inner_error0_);
#line 377 "../src/game-view.vala"
		return;
#line 1794 "game-view.c"
	}
	{
		GdkPixbuf* p = NULL;
		const gchar* _tmp7_;
		GdkPixbuf* _tmp8_;
		GdkPixbuf* _tmp9_;
#line 395 "../src/game-view.vala"
		_tmp7_ = self->priv->pieces_file;
#line 395 "../src/game-view.vala"
		_tmp8_ = gdk_pixbuf_new_from_file_at_scale (_tmp7_, width, height, FALSE, &_inner_error0_);
#line 395 "../src/game-view.vala"
		p = _tmp8_;
#line 395 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1809 "game-view.c"
			goto __catch3_g_error;
		}
#line 396 "../src/game-view.vala"
		_tmp9_ = p;
#line 396 "../src/game-view.vala"
		gdk_cairo_set_source_pixbuf (c, _tmp9_, (gdouble) 0, (gdouble) 0);
#line 397 "../src/game-view.vala"
		cairo_paint (c);
#line 393 "../src/game-view.vala"
		_g_object_unref0 (p);
#line 1820 "game-view.c"
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp10_;
		GError* _tmp11_;
		const gchar* _tmp12_;
#line 393 "../src/game-view.vala"
		e = _inner_error0_;
#line 393 "../src/game-view.vala"
		_inner_error0_ = NULL;
#line 401 "../src/game-view.vala"
		_tmp10_ = self->priv->pieces_file;
#line 401 "../src/game-view.vala"
		_tmp11_ = e;
#line 401 "../src/game-view.vala"
		_tmp12_ = _tmp11_->message;
#line 401 "../src/game-view.vala"
		g_warning ("game-view.vala:401: Failed to load theme image %s: %s", _tmp10_, _tmp12_);
#line 393 "../src/game-view.vala"
		_g_error_free0 (e);
#line 1843 "game-view.c"
	}
	__finally3:
#line 393 "../src/game-view.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 393 "../src/game-view.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 393 "../src/game-view.vala"
		g_clear_error (&_inner_error0_);
#line 393 "../src/game-view.vala"
		return;
#line 1854 "game-view.c"
	}
}

static void
game_view_square_changed_cb (GameView* self,
                             guint8 x,
                             guint8 y,
                             Player replacement)
{
#line 409 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 411 "../src/game-view.vala"
	if (replacement == PLAYER_NONE) {
#line 414 "../src/game-view.vala"
		if (self->priv->show_highlight) {
#line 1870 "game-view.c"
			Game* _tmp0_;
			Game* _tmp1_;
			Game* _tmp2_;
			Game* _tmp3_;
			gboolean _tmp4_;
			gboolean _tmp5_;
#line 416 "../src/game-view.vala"
			self->priv->highlight_state = (guint8) 0;
#line 417 "../src/game-view.vala"
			_tmp0_ = game_view_get_game (self);
#line 417 "../src/game-view.vala"
			_tmp1_ = _tmp0_;
#line 417 "../src/game-view.vala"
			game_view_set_square (self, self->priv->highlight_x, self->priv->highlight_y, game_view_get_pixmap (game_get_owner (_tmp1_, x, y)), FALSE, TRUE);
#line 423 "../src/game-view.vala"
			_tmp2_ = game_view_get_game (self);
#line 423 "../src/game-view.vala"
			_tmp3_ = _tmp2_;
#line 423 "../src/game-view.vala"
			_tmp4_ = game_get_is_complete (_tmp3_);
#line 423 "../src/game-view.vala"
			_tmp5_ = _tmp4_;
#line 423 "../src/game-view.vala"
			if (!_tmp5_) {
#line 424 "../src/game-view.vala"
				self->priv->highlight_state = GAME_VIEW_HIGHLIGHT_MAX;
#line 1897 "game-view.c"
			}
		}
#line 428 "../src/game-view.vala"
		self->priv->highlight_set = TRUE;
#line 429 "../src/game-view.vala"
		self->priv->highlight_x = x;
#line 430 "../src/game-view.vala"
		self->priv->highlight_y = y;
#line 1906 "game-view.c"
	}
#line 433 "../src/game-view.vala"
	game_view_update_square (self, x, y);
#line 1910 "game-view.c"
}

static inline void
game_view_update_square (GameView* self,
                         guint8 x,
                         guint8 y)
{
	Game* _tmp0_;
	Game* _tmp1_;
#line 436 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 436 "../src/game-view.vala"
	_vala_return_if_fail (self->priv->game_is_set, "game_is_set");
#line 439 "../src/game-view.vala"
	_tmp0_ = game_view_get_game (self);
#line 439 "../src/game-view.vala"
	_tmp1_ = _tmp0_;
#line 439 "../src/game-view.vala"
	game_view_set_square (self, x, y, game_view_get_pixmap (game_get_owner (_tmp1_, x, y)), FALSE, FALSE);
#line 1930 "game-view.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 442 "../src/game-view.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 442 "../src/game-view.vala"
	return _data2_;
#line 1940 "game-view.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 442 "../src/game-view.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 1950 "game-view.c"
		GameView* self;
#line 442 "../src/game-view.vala"
		self = _data2_->self;
#line 442 "../src/game-view.vala"
		_g_object_unref0 (self);
#line 442 "../src/game-view.vala"
		g_slice_free (Block2Data, _data2_);
#line 1958 "game-view.c"
	}
}

static gboolean
____lambda7_ (Block2Data* _data2_)
{
	GameView* self;
	gboolean result = FALSE;
	gboolean animating = FALSE;
#line 456 "../src/game-view.vala"
	self = _data2_->self;
#line 457 "../src/game-view.vala"
	animating = FALSE;
#line 1972 "game-view.c"
	{
		guint8 ix = 0U;
#line 459 "../src/game-view.vala"
		ix = (guint8) 0;
#line 1977 "game-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 459 "../src/game-view.vala"
			_tmp0_ = TRUE;
#line 459 "../src/game-view.vala"
			while (TRUE) {
#line 459 "../src/game-view.vala"
				if (!_tmp0_) {
#line 1986 "game-view.c"
					guint8 _tmp1_;
#line 459 "../src/game-view.vala"
					_tmp1_ = ix;
#line 459 "../src/game-view.vala"
					ix = _tmp1_ + 1;
#line 1992 "game-view.c"
				}
#line 459 "../src/game-view.vala"
				_tmp0_ = FALSE;
#line 459 "../src/game-view.vala"
				if (!(ix < self->priv->game_size)) {
#line 459 "../src/game-view.vala"
					break;
#line 2000 "game-view.c"
				}
				{
					guint8 iy = 0U;
#line 461 "../src/game-view.vala"
					iy = (guint8) 0;
#line 2006 "game-view.c"
					{
						gboolean _tmp2_ = FALSE;
#line 461 "../src/game-view.vala"
						_tmp2_ = TRUE;
#line 461 "../src/game-view.vala"
						while (TRUE) {
#line 2013 "game-view.c"
							gint old = 0;
							gint* _tmp4_;
							gint _tmp4__length1;
							gint _tmp4__length2;
							gint _tmp5_;
							gboolean _tmp6_ = FALSE;
							gboolean _tmp7_ = FALSE;
							gint* _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							gint _tmp13_;
#line 461 "../src/game-view.vala"
							if (!_tmp2_) {
#line 2027 "game-view.c"
								guint8 _tmp3_;
#line 461 "../src/game-view.vala"
								_tmp3_ = iy;
#line 461 "../src/game-view.vala"
								iy = _tmp3_ + 1;
#line 2033 "game-view.c"
							}
#line 461 "../src/game-view.vala"
							_tmp2_ = FALSE;
#line 461 "../src/game-view.vala"
							if (!(iy < self->priv->game_size)) {
#line 461 "../src/game-view.vala"
								break;
#line 2041 "game-view.c"
							}
#line 463 "../src/game-view.vala"
							_tmp4_ = self->priv->pixmaps;
#line 463 "../src/game-view.vala"
							_tmp4__length1 = self->priv->pixmaps_length1;
#line 463 "../src/game-view.vala"
							_tmp4__length2 = self->priv->pixmaps_length2;
#line 463 "../src/game-view.vala"
							_tmp5_ = _tmp4_[(ix * _tmp4__length2) + iy];
#line 463 "../src/game-view.vala"
							old = _tmp5_;
#line 465 "../src/game-view.vala"
							if (_data2_->is_final_animation) {
#line 466 "../src/game-view.vala"
								_tmp7_ = self->priv->flip_final_result_now;
#line 2057 "game-view.c"
							} else {
#line 465 "../src/game-view.vala"
								_tmp7_ = FALSE;
#line 2061 "game-view.c"
							}
#line 465 "../src/game-view.vala"
							if (_tmp7_) {
#line 2065 "game-view.c"
								Game* _tmp8_;
								Game* _tmp9_;
								gboolean _tmp10_;
								gboolean _tmp11_;
#line 467 "../src/game-view.vala"
								_tmp8_ = game_view_get_game (self);
#line 467 "../src/game-view.vala"
								_tmp9_ = _tmp8_;
#line 467 "../src/game-view.vala"
								_tmp10_ = game_get_is_complete (_tmp9_);
#line 467 "../src/game-view.vala"
								_tmp11_ = _tmp10_;
#line 467 "../src/game-view.vala"
								_tmp6_ = _tmp11_;
#line 2080 "game-view.c"
							} else {
#line 465 "../src/game-view.vala"
								_tmp6_ = FALSE;
#line 2084 "game-view.c"
							}
#line 465 "../src/game-view.vala"
							if (_tmp6_) {
#line 468 "../src/game-view.vala"
								game_view_flip_final_result_tile (self, ix, iy);
#line 2090 "game-view.c"
							} else {
#line 470 "../src/game-view.vala"
								game_view_update_square (self, ix, iy);
#line 2094 "game-view.c"
							}
#line 472 "../src/game-view.vala"
							_tmp12_ = self->priv->pixmaps;
#line 472 "../src/game-view.vala"
							_tmp12__length1 = self->priv->pixmaps_length1;
#line 472 "../src/game-view.vala"
							_tmp12__length2 = self->priv->pixmaps_length2;
#line 472 "../src/game-view.vala"
							_tmp13_ = _tmp12_[(ix * _tmp12__length2) + iy];
#line 472 "../src/game-view.vala"
							if (_tmp13_ != old) {
#line 473 "../src/game-view.vala"
								animating = TRUE;
#line 2108 "game-view.c"
							}
						}
					}
				}
			}
		}
	}
#line 477 "../src/game-view.vala"
	if (animating) {
#line 478 "../src/game-view.vala"
		result = G_SOURCE_CONTINUE;
#line 478 "../src/game-view.vala"
		return result;
#line 2122 "game-view.c"
	} else {
#line 481 "../src/game-view.vala"
		self->priv->animate_timeout = (guint) 0;
#line 482 "../src/game-view.vala"
		result = G_SOURCE_REMOVE;
#line 482 "../src/game-view.vala"
		return result;
#line 2130 "game-view.c"
	}
}

static gboolean
_____lambda7__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda7_ (self);
#line 456 "../src/game-view.vala"
	return result;
#line 2141 "game-view.c"
}

static void
game_view_set_square (GameView* self,
                      guint8 x,
                      guint8 y,
                      gint pixmap,
                      gboolean is_final_animation,
                      gboolean force_redraw)
{
	Block2Data* _data2_;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gint _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
#line 442 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 442 "../src/game-view.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 442 "../src/game-view.vala"
	_data2_->_ref_count_ = 1;
#line 442 "../src/game-view.vala"
	_data2_->self = g_object_ref (self);
#line 442 "../src/game-view.vala"
	_data2_->is_final_animation = is_final_animation;
#line 444 "../src/game-view.vala"
	if (!force_redraw) {
#line 2171 "game-view.c"
		gint* _tmp1_;
		gint _tmp1__length1;
		gint _tmp1__length2;
		gint _tmp2_;
#line 444 "../src/game-view.vala"
		_tmp1_ = self->priv->pixmaps;
#line 444 "../src/game-view.vala"
		_tmp1__length1 = self->priv->pixmaps_length1;
#line 444 "../src/game-view.vala"
		_tmp1__length2 = self->priv->pixmaps_length2;
#line 444 "../src/game-view.vala"
		_tmp2_ = _tmp1_[(x * _tmp1__length2) + y];
#line 444 "../src/game-view.vala"
		_tmp0_ = _tmp2_ == pixmap;
#line 2186 "game-view.c"
	} else {
#line 444 "../src/game-view.vala"
		_tmp0_ = FALSE;
#line 2190 "game-view.c"
	}
#line 444 "../src/game-view.vala"
	if (_tmp0_) {
#line 445 "../src/game-view.vala"
		block2_data_unref (_data2_);
#line 445 "../src/game-view.vala"
		_data2_ = NULL;
#line 445 "../src/game-view.vala"
		return;
#line 2200 "game-view.c"
	}
#line 447 "../src/game-view.vala"
	if (pixmap == 0) {
#line 447 "../src/game-view.vala"
		_tmp3_ = TRUE;
#line 2206 "game-view.c"
	} else {
		gint* _tmp4_;
		gint _tmp4__length1;
		gint _tmp4__length2;
		gint _tmp5_;
#line 447 "../src/game-view.vala"
		_tmp4_ = self->priv->pixmaps;
#line 447 "../src/game-view.vala"
		_tmp4__length1 = self->priv->pixmaps_length1;
#line 447 "../src/game-view.vala"
		_tmp4__length2 = self->priv->pixmaps_length2;
#line 447 "../src/game-view.vala"
		_tmp5_ = _tmp4_[(x * _tmp4__length2) + y];
#line 447 "../src/game-view.vala"
		_tmp3_ = _tmp5_ == 0;
#line 2222 "game-view.c"
	}
#line 447 "../src/game-view.vala"
	if (_tmp3_) {
#line 2226 "game-view.c"
		gint* _tmp6_;
		gint _tmp6__length1;
		gint _tmp6__length2;
#line 448 "../src/game-view.vala"
		_tmp6_ = self->priv->pixmaps;
#line 448 "../src/game-view.vala"
		_tmp6__length1 = self->priv->pixmaps_length1;
#line 448 "../src/game-view.vala"
		_tmp6__length2 = self->priv->pixmaps_length2;
#line 448 "../src/game-view.vala"
		_tmp6_[(x * _tmp6__length2) + y] = pixmap;
#line 2238 "game-view.c"
	} else {
		gint* _tmp7_;
		gint _tmp7__length1;
		gint _tmp7__length2;
		gint _tmp8_;
#line 451 "../src/game-view.vala"
		_tmp7_ = self->priv->pixmaps;
#line 451 "../src/game-view.vala"
		_tmp7__length1 = self->priv->pixmaps_length1;
#line 451 "../src/game-view.vala"
		_tmp7__length2 = self->priv->pixmaps_length2;
#line 451 "../src/game-view.vala"
		_tmp8_ = _tmp7_[(x * _tmp7__length2) + y];
#line 451 "../src/game-view.vala"
		if (pixmap > _tmp8_) {
#line 2254 "game-view.c"
			gint* _tmp9_;
			gint _tmp9__length1;
			gint _tmp9__length2;
			gint _tmp10_;
#line 452 "../src/game-view.vala"
			_tmp9_ = self->priv->pixmaps;
#line 452 "../src/game-view.vala"
			_tmp9__length1 = self->priv->pixmaps_length1;
#line 452 "../src/game-view.vala"
			_tmp9__length2 = self->priv->pixmaps_length2;
#line 452 "../src/game-view.vala"
			_tmp10_ = _tmp9_[(x * _tmp9__length2) + y];
#line 452 "../src/game-view.vala"
			_tmp9_[(x * _tmp9__length2) + y] = _tmp10_ + 1;
#line 2269 "game-view.c"
		} else {
			gint* _tmp11_;
			gint _tmp11__length1;
			gint _tmp11__length2;
			gint _tmp12_;
#line 454 "../src/game-view.vala"
			_tmp11_ = self->priv->pixmaps;
#line 454 "../src/game-view.vala"
			_tmp11__length1 = self->priv->pixmaps_length1;
#line 454 "../src/game-view.vala"
			_tmp11__length2 = self->priv->pixmaps_length2;
#line 454 "../src/game-view.vala"
			_tmp12_ = _tmp11_[(x * _tmp11__length2) + y];
#line 454 "../src/game-view.vala"
			_tmp11_[(x * _tmp11__length2) + y] = _tmp12_ - 1;
#line 2285 "game-view.c"
		}
#line 455 "../src/game-view.vala"
		if (self->priv->animate_timeout == ((guint) 0)) {
#line 456 "../src/game-view.vala"
			self->priv->animate_timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) GAME_VIEW_PIXMAP_FLIP_DELAY, _____lambda7__gsource_func, block2_data_ref (_data2_), block2_data_unref);
#line 2291 "game-view.c"
		}
	}
#line 486 "../src/game-view.vala"
	_tmp13_ = game_view_get_board_x (self);
#line 486 "../src/game-view.vala"
	_tmp14_ = _tmp13_;
#line 486 "../src/game-view.vala"
	_tmp15_ = game_view_get_board_y (self);
#line 486 "../src/game-view.vala"
	_tmp16_ = _tmp15_;
#line 486 "../src/game-view.vala"
	gtk_widget_queue_draw_area ((GtkWidget*) self, (gint) (_tmp14_ + (x * self->priv->paving_size)), (gint) (_tmp16_ + (y * self->priv->paving_size)), self->priv->tile_size, self->priv->tile_size);
#line 442 "../src/game-view.vala"
	block2_data_unref (_data2_);
#line 442 "../src/game-view.vala"
	_data2_ = NULL;
#line 2308 "game-view.c"
}

static gint
game_view_get_pixmap (Player color)
{
	gint result = 0;
#line 494 "../src/game-view.vala"
	switch (color) {
#line 2317 "game-view.c"
		default:
#line 494 "../src/game-view.vala"
		case PLAYER_NONE:
#line 2321 "game-view.c"
		{
#line 498 "../src/game-view.vala"
			result = 0;
#line 498 "../src/game-view.vala"
			return result;
#line 2327 "game-view.c"
		}
#line 494 "../src/game-view.vala"
		case PLAYER_DARK:
#line 2331 "game-view.c"
		{
#line 500 "../src/game-view.vala"
			result = 1;
#line 500 "../src/game-view.vala"
			return result;
#line 2337 "game-view.c"
		}
#line 494 "../src/game-view.vala"
		case PLAYER_LIGHT:
#line 2341 "game-view.c"
		{
#line 502 "../src/game-view.vala"
			result = 31;
#line 502 "../src/game-view.vala"
			return result;
#line 2347 "game-view.c"
		}
	}
}

static gboolean
__lambda6_ (GameView* self)
{
	gboolean result = FALSE;
	Game* _tmp0_;
	Game* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 531 "../src/game-view.vala"
	_tmp0_ = game_view_get_game (self);
#line 531 "../src/game-view.vala"
	_tmp1_ = _tmp0_;
#line 531 "../src/game-view.vala"
	_tmp2_ = game_get_is_complete (_tmp1_);
#line 531 "../src/game-view.vala"
	_tmp3_ = _tmp2_;
#line 531 "../src/game-view.vala"
	if (!_tmp3_) {
#line 532 "../src/game-view.vala"
		result = G_SOURCE_REMOVE;
#line 532 "../src/game-view.vala"
		return result;
#line 2374 "game-view.c"
	}
#line 534 "../src/game-view.vala"
	game_view_set_winner_and_loser_variables (self);
#line 535 "../src/game-view.vala"
	self->priv->flip_final_result_now = TRUE;
#line 2380 "game-view.c"
	{
		guint8 x = 0U;
#line 536 "../src/game-view.vala"
		x = (guint8) 0;
#line 2385 "game-view.c"
		{
			gboolean _tmp4_ = FALSE;
#line 536 "../src/game-view.vala"
			_tmp4_ = TRUE;
#line 536 "../src/game-view.vala"
			while (TRUE) {
#line 536 "../src/game-view.vala"
				if (!_tmp4_) {
#line 2394 "game-view.c"
					guint8 _tmp5_;
#line 536 "../src/game-view.vala"
					_tmp5_ = x;
#line 536 "../src/game-view.vala"
					x = _tmp5_ + 1;
#line 2400 "game-view.c"
				}
#line 536 "../src/game-view.vala"
				_tmp4_ = FALSE;
#line 536 "../src/game-view.vala"
				if (!(x < self->priv->game_size)) {
#line 536 "../src/game-view.vala"
					break;
#line 2408 "game-view.c"
				}
				{
					guint8 y = 0U;
#line 537 "../src/game-view.vala"
					y = (guint8) 0;
#line 2414 "game-view.c"
					{
						gboolean _tmp6_ = FALSE;
#line 537 "../src/game-view.vala"
						_tmp6_ = TRUE;
#line 537 "../src/game-view.vala"
						while (TRUE) {
#line 537 "../src/game-view.vala"
							if (!_tmp6_) {
#line 2423 "game-view.c"
								guint8 _tmp7_;
#line 537 "../src/game-view.vala"
								_tmp7_ = y;
#line 537 "../src/game-view.vala"
								y = _tmp7_ + 1;
#line 2429 "game-view.c"
							}
#line 537 "../src/game-view.vala"
							_tmp6_ = FALSE;
#line 537 "../src/game-view.vala"
							if (!(y < self->priv->game_size)) {
#line 537 "../src/game-view.vala"
								break;
#line 2437 "game-view.c"
							}
#line 538 "../src/game-view.vala"
							game_view_flip_final_result_tile (self, x, y);
#line 2441 "game-view.c"
						}
					}
				}
			}
		}
	}
#line 540 "../src/game-view.vala"
	result = G_SOURCE_REMOVE;
#line 540 "../src/game-view.vala"
	return result;
#line 2452 "game-view.c"
}

static gboolean
___lambda6__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda6_ ((GameView*) self);
#line 530 "../src/game-view.vala"
	return result;
#line 2462 "game-view.c"
}

static void
game_view_game_is_complete_cb (GameView* self)
{
	Game* _tmp0_;
	Game* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_ = FALSE;
	Game* _tmp5_;
	Game* _tmp6_;
	guint8 _tmp7_;
	guint8 _tmp8_;
#line 518 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 520 "../src/game-view.vala"
	_tmp0_ = game_view_get_game (self);
#line 520 "../src/game-view.vala"
	_tmp1_ = _tmp0_;
#line 520 "../src/game-view.vala"
	_tmp2_ = game_get_is_complete (_tmp1_);
#line 520 "../src/game-view.vala"
	_tmp3_ = _tmp2_;
#line 520 "../src/game-view.vala"
	if (!_tmp3_) {
#line 521 "../src/game-view.vala"
		return;
#line 2491 "game-view.c"
	}
#line 523 "../src/game-view.vala"
	_tmp5_ = game_view_get_game (self);
#line 523 "../src/game-view.vala"
	_tmp6_ = _tmp5_;
#line 523 "../src/game-view.vala"
	_tmp7_ = game_get_n_light_tiles (_tmp6_);
#line 523 "../src/game-view.vala"
	_tmp8_ = _tmp7_;
#line 523 "../src/game-view.vala"
	if (((gint) _tmp8_) == 0) {
#line 523 "../src/game-view.vala"
		_tmp4_ = TRUE;
#line 2505 "game-view.c"
	} else {
		Game* _tmp9_;
		Game* _tmp10_;
		guint8 _tmp11_;
		guint8 _tmp12_;
#line 523 "../src/game-view.vala"
		_tmp9_ = game_view_get_game (self);
#line 523 "../src/game-view.vala"
		_tmp10_ = _tmp9_;
#line 523 "../src/game-view.vala"
		_tmp11_ = game_get_n_dark_tiles (_tmp10_);
#line 523 "../src/game-view.vala"
		_tmp12_ = _tmp11_;
#line 523 "../src/game-view.vala"
		_tmp4_ = ((gint) _tmp12_) == 0;
#line 2521 "game-view.c"
	}
#line 523 "../src/game-view.vala"
	if (_tmp4_) {
#line 524 "../src/game-view.vala"
		return;
#line 2527 "game-view.c"
	}
#line 530 "../src/game-view.vala"
	g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 2, ___lambda6__gsource_func, g_object_ref (self), g_object_unref);
#line 2531 "game-view.c"
}

static void
game_view_flip_final_result_tile (GameView* self,
                                  guint8 x,
                                  guint8 y)
{
	gint pixmap = 0;
	guint8 n = 0U;
#line 544 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 547 "../src/game-view.vala"
	n = (y * self->priv->game_size) + x;
#line 548 "../src/game-view.vala"
	if (((gint) n) < self->priv->n_winning_tiles) {
#line 2547 "game-view.c"
		Player _tmp0_;
#line 549 "../src/game-view.vala"
		_tmp0_ = self->priv->winning_color;
#line 549 "../src/game-view.vala"
		pixmap = game_view_get_pixmap (_tmp0_);
#line 2553 "game-view.c"
	} else {
#line 550 "../src/game-view.vala"
		if (((gint) n) < (self->priv->n_winning_tiles + self->priv->n_losing_tiles)) {
#line 2557 "game-view.c"
			Player _tmp1_;
#line 551 "../src/game-view.vala"
			_tmp1_ = self->priv->losing_color;
#line 551 "../src/game-view.vala"
			pixmap = game_view_get_pixmap (_tmp1_);
#line 2563 "game-view.c"
		} else {
#line 553 "../src/game-view.vala"
			pixmap = game_view_get_pixmap (PLAYER_NONE);
#line 2567 "game-view.c"
		}
	}
#line 554 "../src/game-view.vala"
	game_view_set_square (self, x, y, pixmap, TRUE, FALSE);
#line 2572 "game-view.c"
}

static void
game_view_set_winner_and_loser_variables (GameView* self)
{
	Game* _tmp0_;
	Game* _tmp1_;
	guint8 _tmp2_;
	guint8 _tmp3_;
	Game* _tmp4_;
	Game* _tmp5_;
	guint8 _tmp6_;
	guint8 _tmp7_;
#line 557 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 559 "../src/game-view.vala"
	_tmp0_ = game_view_get_game (self);
#line 559 "../src/game-view.vala"
	_tmp1_ = _tmp0_;
#line 559 "../src/game-view.vala"
	_tmp2_ = game_get_n_light_tiles (_tmp1_);
#line 559 "../src/game-view.vala"
	_tmp3_ = _tmp2_;
#line 559 "../src/game-view.vala"
	self->priv->n_winning_tiles = (gint) _tmp3_;
#line 560 "../src/game-view.vala"
	_tmp4_ = game_view_get_game (self);
#line 560 "../src/game-view.vala"
	_tmp5_ = _tmp4_;
#line 560 "../src/game-view.vala"
	_tmp6_ = game_get_n_dark_tiles (_tmp5_);
#line 560 "../src/game-view.vala"
	_tmp7_ = _tmp6_;
#line 560 "../src/game-view.vala"
	self->priv->n_losing_tiles = (gint) _tmp7_;
#line 561 "../src/game-view.vala"
	if (self->priv->n_losing_tiles > self->priv->n_winning_tiles) {
#line 2610 "game-view.c"
		gint t = 0;
#line 563 "../src/game-view.vala"
		self->priv->winning_color = PLAYER_DARK;
#line 564 "../src/game-view.vala"
		self->priv->losing_color = PLAYER_LIGHT;
#line 565 "../src/game-view.vala"
		t = self->priv->n_winning_tiles;
#line 566 "../src/game-view.vala"
		self->priv->n_winning_tiles = self->priv->n_losing_tiles;
#line 567 "../src/game-view.vala"
		self->priv->n_losing_tiles = t;
#line 2622 "game-view.c"
	} else {
#line 571 "../src/game-view.vala"
		self->priv->winning_color = PLAYER_LIGHT;
#line 572 "../src/game-view.vala"
		self->priv->losing_color = PLAYER_DARK;
#line 2628 "game-view.c"
	}
}

gboolean
game_view_undo_final_animation (GameView* self)
{
	gboolean result = FALSE;
#line 576 "../src/game-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 578 "../src/game-view.vala"
	if (!self->priv->flip_final_result_now) {
#line 579 "../src/game-view.vala"
		result = FALSE;
#line 579 "../src/game-view.vala"
		return result;
#line 2644 "game-view.c"
	}
#line 581 "../src/game-view.vala"
	self->priv->flip_final_result_now = FALSE;
#line 2648 "game-view.c"
	{
		guint8 x = 0U;
#line 582 "../src/game-view.vala"
		x = (guint8) 0;
#line 2653 "game-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 582 "../src/game-view.vala"
			_tmp0_ = TRUE;
#line 582 "../src/game-view.vala"
			while (TRUE) {
#line 582 "../src/game-view.vala"
				if (!_tmp0_) {
#line 2662 "game-view.c"
					guint8 _tmp1_;
#line 582 "../src/game-view.vala"
					_tmp1_ = x;
#line 582 "../src/game-view.vala"
					x = _tmp1_ + 1;
#line 2668 "game-view.c"
				}
#line 582 "../src/game-view.vala"
				_tmp0_ = FALSE;
#line 582 "../src/game-view.vala"
				if (!(x < self->priv->game_size)) {
#line 582 "../src/game-view.vala"
					break;
#line 2676 "game-view.c"
				}
				{
					guint8 y = 0U;
#line 583 "../src/game-view.vala"
					y = (guint8) 0;
#line 2682 "game-view.c"
					{
						gboolean _tmp2_ = FALSE;
#line 583 "../src/game-view.vala"
						_tmp2_ = TRUE;
#line 583 "../src/game-view.vala"
						while (TRUE) {
#line 583 "../src/game-view.vala"
							if (!_tmp2_) {
#line 2691 "game-view.c"
								guint8 _tmp3_;
#line 583 "../src/game-view.vala"
								_tmp3_ = y;
#line 583 "../src/game-view.vala"
								y = _tmp3_ + 1;
#line 2697 "game-view.c"
							}
#line 583 "../src/game-view.vala"
							_tmp2_ = FALSE;
#line 583 "../src/game-view.vala"
							if (!(y < self->priv->game_size)) {
#line 583 "../src/game-view.vala"
								break;
#line 2705 "game-view.c"
							}
#line 584 "../src/game-view.vala"
							game_view_update_square (self, x, y);
#line 2709 "game-view.c"
						}
					}
				}
			}
		}
	}
#line 586 "../src/game-view.vala"
	result = TRUE;
#line 586 "../src/game-view.vala"
	return result;
#line 2720 "game-view.c"
}

static gboolean
game_view_real_button_press_event (GtkWidget* base,
                                   GdkEventButton* event)
{
	GameView * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 593 "../src/game-view.vala"
	self = (GameView*) base;
#line 593 "../src/game-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 595 "../src/game-view.vala"
	if (!self->priv->game_is_set) {
#line 596 "../src/game-view.vala"
		result = FALSE;
#line 596 "../src/game-view.vala"
		return result;
#line 2740 "game-view.c"
	}
#line 598 "../src/game-view.vala"
	if (event->button == ((guint) GDK_BUTTON_PRIMARY)) {
#line 598 "../src/game-view.vala"
		_tmp0_ = TRUE;
#line 2746 "game-view.c"
	} else {
#line 598 "../src/game-view.vala"
		_tmp0_ = event->button == ((guint) GDK_BUTTON_SECONDARY);
#line 2750 "game-view.c"
	}
#line 598 "../src/game-view.vala"
	if (_tmp0_) {
#line 2754 "game-view.c"
		gint8 x = 0;
		gint _tmp1_;
		gint _tmp2_;
		gint8 y = 0;
		gint _tmp3_;
		gint _tmp4_;
		Game* _tmp5_;
		Game* _tmp6_;
#line 600 "../src/game-view.vala"
		_tmp1_ = game_view_get_board_x (self);
#line 600 "../src/game-view.vala"
		_tmp2_ = _tmp1_;
#line 600 "../src/game-view.vala"
		x = (gint8) ((event->x - _tmp2_) / self->priv->paving_size);
#line 601 "../src/game-view.vala"
		_tmp3_ = game_view_get_board_y (self);
#line 601 "../src/game-view.vala"
		_tmp4_ = _tmp3_;
#line 601 "../src/game-view.vala"
		y = (gint8) ((event->y - _tmp4_) / self->priv->paving_size);
#line 602 "../src/game-view.vala"
		_tmp5_ = game_view_get_game (self);
#line 602 "../src/game-view.vala"
		_tmp6_ = _tmp5_;
#line 602 "../src/game-view.vala"
		if (game_is_valid_location_signed (_tmp6_, x, y)) {
#line 604 "../src/game-view.vala"
			self->priv->show_highlight = FALSE;
#line 605 "../src/game-view.vala"
			gtk_widget_queue_draw ((GtkWidget*) self);
#line 606 "../src/game-view.vala"
			self->priv->highlight_set = TRUE;
#line 607 "../src/game-view.vala"
			self->priv->highlight_x = (guint8) x;
#line 608 "../src/game-view.vala"
			self->priv->highlight_y = (guint8) y;
#line 609 "../src/game-view.vala"
			g_signal_emit (self, game_view_signals[GAME_VIEW_MOVE_SIGNAL], 0, self->priv->highlight_x, self->priv->highlight_y);
#line 2793 "game-view.c"
		}
	}
#line 613 "../src/game-view.vala"
	result = TRUE;
#line 613 "../src/game-view.vala"
	return result;
#line 2800 "game-view.c"
}

static gboolean
game_view_real_key_press_event (GtkWidget* base,
                                GdkEventKey* event)
{
	GameView * self;
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	gchar* key = NULL;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp14_ = FALSE;
	guint8 old_highlight_x = 0U;
	guint8 old_highlight_y = 0U;
	const gchar* _tmp62_;
	const gchar* _tmp63_;
	GQuark _tmp65_ = 0U;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label0 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label1 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label2 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label3 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label4 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label5 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label6 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label7 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label8 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label9 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label10 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label11 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label12 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label13 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label14 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label15 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label16 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label17 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label18 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label19 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label20 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label21 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label22 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label23 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label24 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label25 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label26 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label27 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label28 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label29 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label30 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label31 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label32 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label33 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label34 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label35 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label36 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label37 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label38 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label39 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label40 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label41 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label42 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label43 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label44 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label45 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label46 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label47 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label48 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label49 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label50 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label51 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label52 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label53 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label54 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label55 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label56 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label57 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label58 = 0;
#line 639 "../src/game-view.vala"
	static GQuark _tmp64_label59 = 0;
#line 2945 "game-view.c"
	const gchar* _tmp88_;
	gint _tmp89_;
	gint _tmp90_;
	gint _tmp91_;
	gint _tmp92_;
	gboolean _tmp93_ = FALSE;
#line 616 "../src/game-view.vala"
	self = (GameView*) base;
#line 616 "../src/game-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 618 "../src/game-view.vala"
	if (!self->priv->game_is_set) {
#line 619 "../src/game-view.vala"
		result = FALSE;
#line 619 "../src/game-view.vala"
		return result;
#line 2962 "game-view.c"
	}
#line 621 "../src/game-view.vala"
	_tmp1_ = gdk_keyval_name (event->keyval);
#line 621 "../src/game-view.vala"
	_tmp0_ = _tmp1_;
#line 621 "../src/game-view.vala"
	if (_tmp0_ == NULL) {
#line 621 "../src/game-view.vala"
		_tmp0_ = "";
#line 2972 "game-view.c"
	}
#line 621 "../src/game-view.vala"
	_tmp2_ = g_strdup ((const gchar*) _tmp0_);
#line 621 "../src/game-view.vala"
	key = _tmp2_;
#line 623 "../src/game-view.vala"
	if (self->priv->show_highlight) {
#line 2980 "game-view.c"
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
		const gchar* _tmp6_;
#line 623 "../src/game-view.vala"
		_tmp6_ = key;
#line 623 "../src/game-view.vala"
		if (g_strcmp0 (_tmp6_, "space") == 0) {
#line 623 "../src/game-view.vala"
			_tmp5_ = TRUE;
#line 2990 "game-view.c"
		} else {
			const gchar* _tmp7_;
#line 623 "../src/game-view.vala"
			_tmp7_ = key;
#line 623 "../src/game-view.vala"
			_tmp5_ = g_strcmp0 (_tmp7_, "Return") == 0;
#line 2997 "game-view.c"
		}
#line 623 "../src/game-view.vala"
		if (_tmp5_) {
#line 623 "../src/game-view.vala"
			_tmp4_ = TRUE;
#line 3003 "game-view.c"
		} else {
			const gchar* _tmp8_;
#line 623 "../src/game-view.vala"
			_tmp8_ = key;
#line 623 "../src/game-view.vala"
			_tmp4_ = g_strcmp0 (_tmp8_, "KP_Enter") == 0;
#line 3010 "game-view.c"
		}
#line 623 "../src/game-view.vala"
		_tmp3_ = _tmp4_;
#line 3014 "game-view.c"
	} else {
#line 623 "../src/game-view.vala"
		_tmp3_ = FALSE;
#line 3018 "game-view.c"
	}
#line 623 "../src/game-view.vala"
	if (_tmp3_) {
#line 625 "../src/game-view.vala"
		g_signal_emit (self, game_view_signals[GAME_VIEW_MOVE_SIGNAL], 0, self->priv->highlight_x, self->priv->highlight_y);
#line 626 "../src/game-view.vala"
		result = TRUE;
#line 626 "../src/game-view.vala"
		_g_free0 (key);
#line 626 "../src/game-view.vala"
		return result;
#line 3030 "game-view.c"
	}
#line 629 "../src/game-view.vala"
	if (((gint) self->priv->game_size) <= 4) {
#line 3034 "game-view.c"
		gboolean _tmp15_ = FALSE;
		gboolean _tmp16_ = FALSE;
		gboolean _tmp17_ = FALSE;
		const gchar* _tmp18_;
#line 629 "../src/game-view.vala"
		_tmp18_ = key;
#line 629 "../src/game-view.vala"
		if (g_strcmp0 (_tmp18_, "e") == 0) {
#line 629 "../src/game-view.vala"
			_tmp17_ = TRUE;
#line 3045 "game-view.c"
		} else {
			const gchar* _tmp19_;
#line 629 "../src/game-view.vala"
			_tmp19_ = key;
#line 629 "../src/game-view.vala"
			_tmp17_ = g_strcmp0 (_tmp19_, "E") == 0;
#line 3052 "game-view.c"
		}
#line 629 "../src/game-view.vala"
		if (_tmp17_) {
#line 629 "../src/game-view.vala"
			_tmp16_ = TRUE;
#line 3058 "game-view.c"
		} else {
			const gchar* _tmp20_;
#line 629 "../src/game-view.vala"
			_tmp20_ = key;
#line 629 "../src/game-view.vala"
			_tmp16_ = g_strcmp0 (_tmp20_, "5") == 0;
#line 3065 "game-view.c"
		}
#line 629 "../src/game-view.vala"
		if (_tmp16_) {
#line 629 "../src/game-view.vala"
			_tmp15_ = TRUE;
#line 3071 "game-view.c"
		} else {
			const gchar* _tmp21_;
#line 629 "../src/game-view.vala"
			_tmp21_ = key;
#line 629 "../src/game-view.vala"
			_tmp15_ = g_strcmp0 (_tmp21_, "KP_5") == 0;
#line 3078 "game-view.c"
		}
#line 629 "../src/game-view.vala"
		_tmp14_ = _tmp15_;
#line 3082 "game-view.c"
	} else {
#line 629 "../src/game-view.vala"
		_tmp14_ = FALSE;
#line 3086 "game-view.c"
	}
#line 629 "../src/game-view.vala"
	if (_tmp14_) {
#line 629 "../src/game-view.vala"
		_tmp13_ = TRUE;
#line 3092 "game-view.c"
	} else {
		gboolean _tmp22_ = FALSE;
#line 630 "../src/game-view.vala"
		if (((gint) self->priv->game_size) <= 5) {
#line 3097 "game-view.c"
			gboolean _tmp23_ = FALSE;
			gboolean _tmp24_ = FALSE;
			gboolean _tmp25_ = FALSE;
			const gchar* _tmp26_;
#line 630 "../src/game-view.vala"
			_tmp26_ = key;
#line 630 "../src/game-view.vala"
			if (g_strcmp0 (_tmp26_, "f") == 0) {
#line 630 "../src/game-view.vala"
				_tmp25_ = TRUE;
#line 3108 "game-view.c"
			} else {
				const gchar* _tmp27_;
#line 630 "../src/game-view.vala"
				_tmp27_ = key;
#line 630 "../src/game-view.vala"
				_tmp25_ = g_strcmp0 (_tmp27_, "F") == 0;
#line 3115 "game-view.c"
			}
#line 630 "../src/game-view.vala"
			if (_tmp25_) {
#line 630 "../src/game-view.vala"
				_tmp24_ = TRUE;
#line 3121 "game-view.c"
			} else {
				const gchar* _tmp28_;
#line 630 "../src/game-view.vala"
				_tmp28_ = key;
#line 630 "../src/game-view.vala"
				_tmp24_ = g_strcmp0 (_tmp28_, "6") == 0;
#line 3128 "game-view.c"
			}
#line 630 "../src/game-view.vala"
			if (_tmp24_) {
#line 630 "../src/game-view.vala"
				_tmp23_ = TRUE;
#line 3134 "game-view.c"
			} else {
				const gchar* _tmp29_;
#line 630 "../src/game-view.vala"
				_tmp29_ = key;
#line 630 "../src/game-view.vala"
				_tmp23_ = g_strcmp0 (_tmp29_, "KP_6") == 0;
#line 3141 "game-view.c"
			}
#line 630 "../src/game-view.vala"
			_tmp22_ = _tmp23_;
#line 3145 "game-view.c"
		} else {
#line 630 "../src/game-view.vala"
			_tmp22_ = FALSE;
#line 3149 "game-view.c"
		}
#line 630 "../src/game-view.vala"
		_tmp13_ = _tmp22_;
#line 3153 "game-view.c"
	}
#line 629 "../src/game-view.vala"
	if (_tmp13_) {
#line 629 "../src/game-view.vala"
		_tmp12_ = TRUE;
#line 3159 "game-view.c"
	} else {
		gboolean _tmp30_ = FALSE;
#line 631 "../src/game-view.vala"
		if (((gint) self->priv->game_size) <= 6) {
#line 3164 "game-view.c"
			gboolean _tmp31_ = FALSE;
			gboolean _tmp32_ = FALSE;
			gboolean _tmp33_ = FALSE;
			const gchar* _tmp34_;
#line 631 "../src/game-view.vala"
			_tmp34_ = key;
#line 631 "../src/game-view.vala"
			if (g_strcmp0 (_tmp34_, "g") == 0) {
#line 631 "../src/game-view.vala"
				_tmp33_ = TRUE;
#line 3175 "game-view.c"
			} else {
				const gchar* _tmp35_;
#line 631 "../src/game-view.vala"
				_tmp35_ = key;
#line 631 "../src/game-view.vala"
				_tmp33_ = g_strcmp0 (_tmp35_, "G") == 0;
#line 3182 "game-view.c"
			}
#line 631 "../src/game-view.vala"
			if (_tmp33_) {
#line 631 "../src/game-view.vala"
				_tmp32_ = TRUE;
#line 3188 "game-view.c"
			} else {
				const gchar* _tmp36_;
#line 631 "../src/game-view.vala"
				_tmp36_ = key;
#line 631 "../src/game-view.vala"
				_tmp32_ = g_strcmp0 (_tmp36_, "7") == 0;
#line 3195 "game-view.c"
			}
#line 631 "../src/game-view.vala"
			if (_tmp32_) {
#line 631 "../src/game-view.vala"
				_tmp31_ = TRUE;
#line 3201 "game-view.c"
			} else {
				const gchar* _tmp37_;
#line 631 "../src/game-view.vala"
				_tmp37_ = key;
#line 631 "../src/game-view.vala"
				_tmp31_ = g_strcmp0 (_tmp37_, "KP_7") == 0;
#line 3208 "game-view.c"
			}
#line 631 "../src/game-view.vala"
			_tmp30_ = _tmp31_;
#line 3212 "game-view.c"
		} else {
#line 631 "../src/game-view.vala"
			_tmp30_ = FALSE;
#line 3216 "game-view.c"
		}
#line 631 "../src/game-view.vala"
		_tmp12_ = _tmp30_;
#line 3220 "game-view.c"
	}
#line 629 "../src/game-view.vala"
	if (_tmp12_) {
#line 629 "../src/game-view.vala"
		_tmp11_ = TRUE;
#line 3226 "game-view.c"
	} else {
		gboolean _tmp38_ = FALSE;
#line 632 "../src/game-view.vala"
		if (((gint) self->priv->game_size) <= 7) {
#line 3231 "game-view.c"
			gboolean _tmp39_ = FALSE;
			gboolean _tmp40_ = FALSE;
			gboolean _tmp41_ = FALSE;
			const gchar* _tmp42_;
#line 632 "../src/game-view.vala"
			_tmp42_ = key;
#line 632 "../src/game-view.vala"
			if (g_strcmp0 (_tmp42_, "h") == 0) {
#line 632 "../src/game-view.vala"
				_tmp41_ = TRUE;
#line 3242 "game-view.c"
			} else {
				const gchar* _tmp43_;
#line 632 "../src/game-view.vala"
				_tmp43_ = key;
#line 632 "../src/game-view.vala"
				_tmp41_ = g_strcmp0 (_tmp43_, "H") == 0;
#line 3249 "game-view.c"
			}
#line 632 "../src/game-view.vala"
			if (_tmp41_) {
#line 632 "../src/game-view.vala"
				_tmp40_ = TRUE;
#line 3255 "game-view.c"
			} else {
				const gchar* _tmp44_;
#line 632 "../src/game-view.vala"
				_tmp44_ = key;
#line 632 "../src/game-view.vala"
				_tmp40_ = g_strcmp0 (_tmp44_, "8") == 0;
#line 3262 "game-view.c"
			}
#line 632 "../src/game-view.vala"
			if (_tmp40_) {
#line 632 "../src/game-view.vala"
				_tmp39_ = TRUE;
#line 3268 "game-view.c"
			} else {
				const gchar* _tmp45_;
#line 632 "../src/game-view.vala"
				_tmp45_ = key;
#line 632 "../src/game-view.vala"
				_tmp39_ = g_strcmp0 (_tmp45_, "KP_8") == 0;
#line 3275 "game-view.c"
			}
#line 632 "../src/game-view.vala"
			_tmp38_ = _tmp39_;
#line 3279 "game-view.c"
		} else {
#line 632 "../src/game-view.vala"
			_tmp38_ = FALSE;
#line 3283 "game-view.c"
		}
#line 632 "../src/game-view.vala"
		_tmp11_ = _tmp38_;
#line 3287 "game-view.c"
	}
#line 629 "../src/game-view.vala"
	if (_tmp11_) {
#line 629 "../src/game-view.vala"
		_tmp10_ = TRUE;
#line 3293 "game-view.c"
	} else {
		gboolean _tmp46_ = FALSE;
#line 633 "../src/game-view.vala"
		if (((gint) self->priv->game_size) <= 8) {
#line 3298 "game-view.c"
			gboolean _tmp47_ = FALSE;
			gboolean _tmp48_ = FALSE;
			gboolean _tmp49_ = FALSE;
			const gchar* _tmp50_;
#line 633 "../src/game-view.vala"
			_tmp50_ = key;
#line 633 "../src/game-view.vala"
			if (g_strcmp0 (_tmp50_, "i") == 0) {
#line 633 "../src/game-view.vala"
				_tmp49_ = TRUE;
#line 3309 "game-view.c"
			} else {
				const gchar* _tmp51_;
#line 633 "../src/game-view.vala"
				_tmp51_ = key;
#line 633 "../src/game-view.vala"
				_tmp49_ = g_strcmp0 (_tmp51_, "I") == 0;
#line 3316 "game-view.c"
			}
#line 633 "../src/game-view.vala"
			if (_tmp49_) {
#line 633 "../src/game-view.vala"
				_tmp48_ = TRUE;
#line 3322 "game-view.c"
			} else {
				const gchar* _tmp52_;
#line 633 "../src/game-view.vala"
				_tmp52_ = key;
#line 633 "../src/game-view.vala"
				_tmp48_ = g_strcmp0 (_tmp52_, "9") == 0;
#line 3329 "game-view.c"
			}
#line 633 "../src/game-view.vala"
			if (_tmp48_) {
#line 633 "../src/game-view.vala"
				_tmp47_ = TRUE;
#line 3335 "game-view.c"
			} else {
				const gchar* _tmp53_;
#line 633 "../src/game-view.vala"
				_tmp53_ = key;
#line 633 "../src/game-view.vala"
				_tmp47_ = g_strcmp0 (_tmp53_, "KP_9") == 0;
#line 3342 "game-view.c"
			}
#line 633 "../src/game-view.vala"
			_tmp46_ = _tmp47_;
#line 3346 "game-view.c"
		} else {
#line 633 "../src/game-view.vala"
			_tmp46_ = FALSE;
#line 3350 "game-view.c"
		}
#line 633 "../src/game-view.vala"
		_tmp10_ = _tmp46_;
#line 3354 "game-view.c"
	}
#line 629 "../src/game-view.vala"
	if (_tmp10_) {
#line 629 "../src/game-view.vala"
		_tmp9_ = TRUE;
#line 3360 "game-view.c"
	} else {
		gboolean _tmp54_ = FALSE;
#line 634 "../src/game-view.vala"
		if (((gint) self->priv->game_size) <= 9) {
#line 3365 "game-view.c"
			gboolean _tmp55_ = FALSE;
			gboolean _tmp56_ = FALSE;
			gboolean _tmp57_ = FALSE;
			const gchar* _tmp58_;
#line 634 "../src/game-view.vala"
			_tmp58_ = key;
#line 634 "../src/game-view.vala"
			if (g_strcmp0 (_tmp58_, "j") == 0) {
#line 634 "../src/game-view.vala"
				_tmp57_ = TRUE;
#line 3376 "game-view.c"
			} else {
				const gchar* _tmp59_;
#line 634 "../src/game-view.vala"
				_tmp59_ = key;
#line 634 "../src/game-view.vala"
				_tmp57_ = g_strcmp0 (_tmp59_, "J") == 0;
#line 3383 "game-view.c"
			}
#line 634 "../src/game-view.vala"
			if (_tmp57_) {
#line 634 "../src/game-view.vala"
				_tmp56_ = TRUE;
#line 3389 "game-view.c"
			} else {
				const gchar* _tmp60_;
#line 634 "../src/game-view.vala"
				_tmp60_ = key;
#line 634 "../src/game-view.vala"
				_tmp56_ = g_strcmp0 (_tmp60_, "0") == 0;
#line 3396 "game-view.c"
			}
#line 634 "../src/game-view.vala"
			if (_tmp56_) {
#line 634 "../src/game-view.vala"
				_tmp55_ = TRUE;
#line 3402 "game-view.c"
			} else {
				const gchar* _tmp61_;
#line 634 "../src/game-view.vala"
				_tmp61_ = key;
#line 634 "../src/game-view.vala"
				_tmp55_ = g_strcmp0 (_tmp61_, "KP_0") == 0;
#line 3409 "game-view.c"
			}
#line 634 "../src/game-view.vala"
			_tmp54_ = _tmp55_;
#line 3413 "game-view.c"
		} else {
#line 634 "../src/game-view.vala"
			_tmp54_ = FALSE;
#line 3417 "game-view.c"
		}
#line 634 "../src/game-view.vala"
		_tmp9_ = _tmp54_;
#line 3421 "game-view.c"
	}
#line 629 "../src/game-view.vala"
	if (_tmp9_) {
#line 635 "../src/game-view.vala"
		result = FALSE;
#line 635 "../src/game-view.vala"
		_g_free0 (key);
#line 635 "../src/game-view.vala"
		return result;
#line 3431 "game-view.c"
	}
#line 637 "../src/game-view.vala"
	old_highlight_x = self->priv->highlight_x;
#line 638 "../src/game-view.vala"
	old_highlight_y = self->priv->highlight_y;
#line 639 "../src/game-view.vala"
	_tmp62_ = key;
#line 639 "../src/game-view.vala"
	_tmp63_ = _tmp62_;
#line 639 "../src/game-view.vala"
	_tmp65_ = (NULL == _tmp63_) ? 0 : g_quark_from_string (_tmp63_);
#line 639 "../src/game-view.vala"
	if ((_tmp65_ == ((0 != _tmp64_label0) ? _tmp64_label0 : (_tmp64_label0 = g_quark_from_static_string ("Left")))) || (_tmp65_ == ((0 != _tmp64_label1) ? _tmp64_label1 : (_tmp64_label1 = g_quark_from_static_string ("KP_Left"))))) {
#line 639 "../src/game-view.vala"
		switch (0) {
#line 3447 "game-view.c"
			default:
			{
				gboolean _tmp66_ = FALSE;
#line 643 "../src/game-view.vala"
				if (!self->priv->highlight_set) {
#line 3453 "game-view.c"
					Game* _tmp67_;
					Game* _tmp68_;
					Player _tmp69_;
					Player _tmp70_;
#line 643 "../src/game-view.vala"
					_tmp67_ = game_view_get_game (self);
#line 643 "../src/game-view.vala"
					_tmp68_ = _tmp67_;
#line 643 "../src/game-view.vala"
					_tmp69_ = game_get_current_color (_tmp68_);
#line 643 "../src/game-view.vala"
					_tmp70_ = _tmp69_;
#line 643 "../src/game-view.vala"
					_tmp66_ = _tmp70_ == PLAYER_LIGHT;
#line 3468 "game-view.c"
				} else {
#line 643 "../src/game-view.vala"
					_tmp66_ = FALSE;
#line 3472 "game-view.c"
				}
#line 643 "../src/game-view.vala"
				if (_tmp66_) {
#line 643 "../src/game-view.vala"
					self->priv->highlight_y = (guint8) (self->priv->game_size / 2);
#line 3478 "game-view.c"
				}
#line 644 "../src/game-view.vala"
				if (((gint) self->priv->highlight_x) > 0) {
#line 3482 "game-view.c"
					guint8 _tmp71_;
#line 644 "../src/game-view.vala"
					_tmp71_ = self->priv->highlight_x;
#line 644 "../src/game-view.vala"
					self->priv->highlight_x = _tmp71_ - 1;
#line 3488 "game-view.c"
				}
#line 645 "../src/game-view.vala"
				break;
#line 3492 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label2) ? _tmp64_label2 : (_tmp64_label2 = g_quark_from_static_string ("Right")))) || (_tmp65_ == ((0 != _tmp64_label3) ? _tmp64_label3 : (_tmp64_label3 = g_quark_from_static_string ("KP_Right"))))) {
#line 639 "../src/game-view.vala"
		switch (0) {
#line 3498 "game-view.c"
			default:
			{
#line 648 "../src/game-view.vala"
				if (!self->priv->highlight_set) {
#line 3503 "game-view.c"
					Game* _tmp72_;
					Game* _tmp73_;
					Player _tmp74_;
					Player _tmp75_;
#line 650 "../src/game-view.vala"
					self->priv->highlight_x = (guint8) (self->priv->game_size / 2);
#line 651 "../src/game-view.vala"
					_tmp72_ = game_view_get_game (self);
#line 651 "../src/game-view.vala"
					_tmp73_ = _tmp72_;
#line 651 "../src/game-view.vala"
					_tmp74_ = game_get_current_color (_tmp73_);
#line 651 "../src/game-view.vala"
					_tmp75_ = _tmp74_;
#line 651 "../src/game-view.vala"
					if (_tmp75_ == PLAYER_DARK) {
#line 651 "../src/game-view.vala"
						self->priv->highlight_y = self->priv->highlight_x;
#line 3522 "game-view.c"
					}
				}
#line 653 "../src/game-view.vala"
				if (((gint) self->priv->highlight_x) < (self->priv->game_size - 1)) {
#line 3527 "game-view.c"
					guint8 _tmp76_;
#line 653 "../src/game-view.vala"
					_tmp76_ = self->priv->highlight_x;
#line 653 "../src/game-view.vala"
					self->priv->highlight_x = _tmp76_ + 1;
#line 3533 "game-view.c"
				}
#line 654 "../src/game-view.vala"
				break;
#line 3537 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label4) ? _tmp64_label4 : (_tmp64_label4 = g_quark_from_static_string ("Up")))) || (_tmp65_ == ((0 != _tmp64_label5) ? _tmp64_label5 : (_tmp64_label5 = g_quark_from_static_string ("KP_Up"))))) {
#line 639 "../src/game-view.vala"
		switch (0) {
#line 3543 "game-view.c"
			default:
			{
				gboolean _tmp77_ = FALSE;
#line 657 "../src/game-view.vala"
				if (!self->priv->highlight_set) {
#line 3549 "game-view.c"
					Game* _tmp78_;
					Game* _tmp79_;
					Player _tmp80_;
					Player _tmp81_;
#line 657 "../src/game-view.vala"
					_tmp78_ = game_view_get_game (self);
#line 657 "../src/game-view.vala"
					_tmp79_ = _tmp78_;
#line 657 "../src/game-view.vala"
					_tmp80_ = game_get_current_color (_tmp79_);
#line 657 "../src/game-view.vala"
					_tmp81_ = _tmp80_;
#line 657 "../src/game-view.vala"
					_tmp77_ = _tmp81_ == PLAYER_LIGHT;
#line 3564 "game-view.c"
				} else {
#line 657 "../src/game-view.vala"
					_tmp77_ = FALSE;
#line 3568 "game-view.c"
				}
#line 657 "../src/game-view.vala"
				if (_tmp77_) {
#line 657 "../src/game-view.vala"
					self->priv->highlight_x = (guint8) (self->priv->game_size / 2);
#line 3574 "game-view.c"
				}
#line 658 "../src/game-view.vala"
				if (((gint) self->priv->highlight_y) > 0) {
#line 3578 "game-view.c"
					guint8 _tmp82_;
#line 658 "../src/game-view.vala"
					_tmp82_ = self->priv->highlight_y;
#line 658 "../src/game-view.vala"
					self->priv->highlight_y = _tmp82_ - 1;
#line 3584 "game-view.c"
				}
#line 659 "../src/game-view.vala"
				break;
#line 3588 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label6) ? _tmp64_label6 : (_tmp64_label6 = g_quark_from_static_string ("Down")))) || (_tmp65_ == ((0 != _tmp64_label7) ? _tmp64_label7 : (_tmp64_label7 = g_quark_from_static_string ("KP_Down"))))) {
#line 639 "../src/game-view.vala"
		switch (0) {
#line 3594 "game-view.c"
			default:
			{
#line 662 "../src/game-view.vala"
				if (!self->priv->highlight_set) {
#line 3599 "game-view.c"
					Game* _tmp83_;
					Game* _tmp84_;
					Player _tmp85_;
					Player _tmp86_;
#line 664 "../src/game-view.vala"
					self->priv->highlight_y = (guint8) (self->priv->game_size / 2);
#line 665 "../src/game-view.vala"
					_tmp83_ = game_view_get_game (self);
#line 665 "../src/game-view.vala"
					_tmp84_ = _tmp83_;
#line 665 "../src/game-view.vala"
					_tmp85_ = game_get_current_color (_tmp84_);
#line 665 "../src/game-view.vala"
					_tmp86_ = _tmp85_;
#line 665 "../src/game-view.vala"
					if (_tmp86_ == PLAYER_DARK) {
#line 665 "../src/game-view.vala"
						self->priv->highlight_x = self->priv->highlight_y;
#line 3618 "game-view.c"
					}
				}
#line 667 "../src/game-view.vala"
				if (((gint) self->priv->highlight_y) < (self->priv->game_size - 1)) {
#line 3623 "game-view.c"
					guint8 _tmp87_;
#line 667 "../src/game-view.vala"
					_tmp87_ = self->priv->highlight_y;
#line 667 "../src/game-view.vala"
					self->priv->highlight_y = _tmp87_ + 1;
#line 3629 "game-view.c"
				}
#line 668 "../src/game-view.vala"
				break;
#line 3633 "game-view.c"
			}
		}
	} else if ((((_tmp65_ == ((0 != _tmp64_label8) ? _tmp64_label8 : (_tmp64_label8 = g_quark_from_static_string ("space")))) || (_tmp65_ == ((0 != _tmp64_label9) ? _tmp64_label9 : (_tmp64_label9 = g_quark_from_static_string ("Return"))))) || (_tmp65_ == ((0 != _tmp64_label10) ? _tmp64_label10 : (_tmp64_label10 = g_quark_from_static_string ("KP_Enter"))))) || (_tmp65_ == ((0 != _tmp64_label11) ? _tmp64_label11 : (_tmp64_label11 = g_quark_from_static_string ("Escape"))))) {
#line 639 "../src/game-view.vala"
		switch (0) {
#line 3639 "game-view.c"
			default:
			{
#line 674 "../src/game-view.vala"
				break;
#line 3644 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label12) ? _tmp64_label12 : (_tmp64_label12 = g_quark_from_static_string ("a")))) || (_tmp65_ == ((0 != _tmp64_label13) ? _tmp64_label13 : (_tmp64_label13 = g_quark_from_static_string ("A"))))) {
#line 639 "../src/game-view.vala"
		switch (0) {
#line 3650 "game-view.c"
			default:
			{
#line 676 "../src/game-view.vala"
				self->priv->highlight_x = (guint8) 0;
#line 676 "../src/game-view.vala"
				break;
#line 3657 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label14) ? _tmp64_label14 : (_tmp64_label14 = g_quark_from_static_string ("b")))) || (_tmp65_ == ((0 != _tmp64_label15) ? _tmp64_label15 : (_tmp64_label15 = g_quark_from_static_string ("B"))))) {
#line 639 "../src/game-view.vala"
		switch (0) {
#line 3663 "game-view.c"
			default:
			{
#line 677 "../src/game-view.vala"
				self->priv->highlight_x = (guint8) 1;
#line 677 "../src/game-view.vala"
				break;
#line 3670 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label16) ? _tmp64_label16 : (_tmp64_label16 = g_quark_from_static_string ("c")))) || (_tmp65_ == ((0 != _tmp64_label17) ? _tmp64_label17 : (_tmp64_label17 = g_quark_from_static_string ("C"))))) {
#line 639 "../src/game-view.vala"
		switch (0) {
#line 3676 "game-view.c"
			default:
			{
#line 678 "../src/game-view.vala"
				self->priv->highlight_x = (guint8) 2;
#line 678 "../src/game-view.vala"
				break;
#line 3683 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label18) ? _tmp64_label18 : (_tmp64_label18 = g_quark_from_static_string ("d")))) || (_tmp65_ == ((0 != _tmp64_label19) ? _tmp64_label19 : (_tmp64_label19 = g_quark_from_static_string ("D"))))) {
#line 639 "../src/game-view.vala"
		switch (0) {
#line 3689 "game-view.c"
			default:
			{
#line 679 "../src/game-view.vala"
				self->priv->highlight_x = (guint8) 3;
#line 679 "../src/game-view.vala"
				break;
#line 3696 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label20) ? _tmp64_label20 : (_tmp64_label20 = g_quark_from_static_string ("e")))) || (_tmp65_ == ((0 != _tmp64_label21) ? _tmp64_label21 : (_tmp64_label21 = g_quark_from_static_string ("E"))))) {
#line 639 "../src/game-view.vala"
		switch (0) {
#line 3702 "game-view.c"
			default:
			{
#line 680 "../src/game-view.vala"
				self->priv->highlight_x = (guint8) 4;
#line 680 "../src/game-view.vala"
				break;
#line 3709 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label22) ? _tmp64_label22 : (_tmp64_label22 = g_quark_from_static_string ("f")))) || (_tmp65_ == ((0 != _tmp64_label23) ? _tmp64_label23 : (_tmp64_label23 = g_quark_from_static_string ("F"))))) {
#line 639 "../src/game-view.vala"
		switch (0) {
#line 3715 "game-view.c"
			default:
			{
#line 681 "../src/game-view.vala"
				self->priv->highlight_x = (guint8) 5;
#line 681 "../src/game-view.vala"
				break;
#line 3722 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label24) ? _tmp64_label24 : (_tmp64_label24 = g_quark_from_static_string ("g")))) || (_tmp65_ == ((0 != _tmp64_label25) ? _tmp64_label25 : (_tmp64_label25 = g_quark_from_static_string ("G"))))) {
#line 639 "../src/game-view.vala"
		switch (0) {
#line 3728 "game-view.c"
			default:
			{
#line 682 "../src/game-view.vala"
				self->priv->highlight_x = (guint8) 6;
#line 682 "../src/game-view.vala"
				break;
#line 3735 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label26) ? _tmp64_label26 : (_tmp64_label26 = g_quark_from_static_string ("h")))) || (_tmp65_ == ((0 != _tmp64_label27) ? _tmp64_label27 : (_tmp64_label27 = g_quark_from_static_string ("H"))))) {
#line 639 "../src/game-view.vala"
		switch (0) {
#line 3741 "game-view.c"
			default:
			{
#line 683 "../src/game-view.vala"
				self->priv->highlight_x = (guint8) 7;
#line 683 "../src/game-view.vala"
				break;
#line 3748 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label28) ? _tmp64_label28 : (_tmp64_label28 = g_quark_from_static_string ("i")))) || (_tmp65_ == ((0 != _tmp64_label29) ? _tmp64_label29 : (_tmp64_label29 = g_quark_from_static_string ("I"))))) {
#line 639 "../src/game-view.vala"
		switch (0) {
#line 3754 "game-view.c"
			default:
			{
#line 684 "../src/game-view.vala"
				self->priv->highlight_x = (guint8) 8;
#line 684 "../src/game-view.vala"
				break;
#line 3761 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label30) ? _tmp64_label30 : (_tmp64_label30 = g_quark_from_static_string ("j")))) || (_tmp65_ == ((0 != _tmp64_label31) ? _tmp64_label31 : (_tmp64_label31 = g_quark_from_static_string ("J"))))) {
#line 639 "../src/game-view.vala"
		switch (0) {
#line 3767 "game-view.c"
			default:
			{
#line 685 "../src/game-view.vala"
				self->priv->highlight_x = (guint8) 9;
#line 685 "../src/game-view.vala"
				break;
#line 3774 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label32) ? _tmp64_label32 : (_tmp64_label32 = g_quark_from_static_string ("1")))) || (_tmp65_ == ((0 != _tmp64_label33) ? _tmp64_label33 : (_tmp64_label33 = g_quark_from_static_string ("KP_1"))))) {
#line 639 "../src/game-view.vala"
		switch (0) {
#line 3780 "game-view.c"
			default:
			{
#line 687 "../src/game-view.vala"
				self->priv->highlight_y = (guint8) 0;
#line 687 "../src/game-view.vala"
				break;
#line 3787 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label34) ? _tmp64_label34 : (_tmp64_label34 = g_quark_from_static_string ("2")))) || (_tmp65_ == ((0 != _tmp64_label35) ? _tmp64_label35 : (_tmp64_label35 = g_quark_from_static_string ("KP_2"))))) {
#line 639 "../src/game-view.vala"
		switch (0) {
#line 3793 "game-view.c"
			default:
			{
#line 688 "../src/game-view.vala"
				self->priv->highlight_y = (guint8) 1;
#line 688 "../src/game-view.vala"
				break;
#line 3800 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label36) ? _tmp64_label36 : (_tmp64_label36 = g_quark_from_static_string ("3")))) || (_tmp65_ == ((0 != _tmp64_label37) ? _tmp64_label37 : (_tmp64_label37 = g_quark_from_static_string ("KP_3"))))) {
#line 639 "../src/game-view.vala"
		switch (0) {
#line 3806 "game-view.c"
			default:
			{
#line 689 "../src/game-view.vala"
				self->priv->highlight_y = (guint8) 2;
#line 689 "../src/game-view.vala"
				break;
#line 3813 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label38) ? _tmp64_label38 : (_tmp64_label38 = g_quark_from_static_string ("4")))) || (_tmp65_ == ((0 != _tmp64_label39) ? _tmp64_label39 : (_tmp64_label39 = g_quark_from_static_string ("KP_4"))))) {
#line 639 "../src/game-view.vala"
		switch (0) {
#line 3819 "game-view.c"
			default:
			{
#line 690 "../src/game-view.vala"
				self->priv->highlight_y = (guint8) 3;
#line 690 "../src/game-view.vala"
				break;
#line 3826 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label40) ? _tmp64_label40 : (_tmp64_label40 = g_quark_from_static_string ("5")))) || (_tmp65_ == ((0 != _tmp64_label41) ? _tmp64_label41 : (_tmp64_label41 = g_quark_from_static_string ("KP_5"))))) {
#line 639 "../src/game-view.vala"
		switch (0) {
#line 3832 "game-view.c"
			default:
			{
#line 691 "../src/game-view.vala"
				self->priv->highlight_y = (guint8) 4;
#line 691 "../src/game-view.vala"
				break;
#line 3839 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label42) ? _tmp64_label42 : (_tmp64_label42 = g_quark_from_static_string ("6")))) || (_tmp65_ == ((0 != _tmp64_label43) ? _tmp64_label43 : (_tmp64_label43 = g_quark_from_static_string ("KP_6"))))) {
#line 639 "../src/game-view.vala"
		switch (0) {
#line 3845 "game-view.c"
			default:
			{
#line 692 "../src/game-view.vala"
				self->priv->highlight_y = (guint8) 5;
#line 692 "../src/game-view.vala"
				break;
#line 3852 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label44) ? _tmp64_label44 : (_tmp64_label44 = g_quark_from_static_string ("7")))) || (_tmp65_ == ((0 != _tmp64_label45) ? _tmp64_label45 : (_tmp64_label45 = g_quark_from_static_string ("KP_7"))))) {
#line 639 "../src/game-view.vala"
		switch (0) {
#line 3858 "game-view.c"
			default:
			{
#line 693 "../src/game-view.vala"
				self->priv->highlight_y = (guint8) 6;
#line 693 "../src/game-view.vala"
				break;
#line 3865 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label46) ? _tmp64_label46 : (_tmp64_label46 = g_quark_from_static_string ("8")))) || (_tmp65_ == ((0 != _tmp64_label47) ? _tmp64_label47 : (_tmp64_label47 = g_quark_from_static_string ("KP_8"))))) {
#line 639 "../src/game-view.vala"
		switch (0) {
#line 3871 "game-view.c"
			default:
			{
#line 694 "../src/game-view.vala"
				self->priv->highlight_y = (guint8) 7;
#line 694 "../src/game-view.vala"
				break;
#line 3878 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label48) ? _tmp64_label48 : (_tmp64_label48 = g_quark_from_static_string ("9")))) || (_tmp65_ == ((0 != _tmp64_label49) ? _tmp64_label49 : (_tmp64_label49 = g_quark_from_static_string ("KP_9"))))) {
#line 639 "../src/game-view.vala"
		switch (0) {
#line 3884 "game-view.c"
			default:
			{
#line 695 "../src/game-view.vala"
				self->priv->highlight_y = (guint8) 8;
#line 695 "../src/game-view.vala"
				break;
#line 3891 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label50) ? _tmp64_label50 : (_tmp64_label50 = g_quark_from_static_string ("0")))) || (_tmp65_ == ((0 != _tmp64_label51) ? _tmp64_label51 : (_tmp64_label51 = g_quark_from_static_string ("KP_0"))))) {
#line 639 "../src/game-view.vala"
		switch (0) {
#line 3897 "game-view.c"
			default:
			{
#line 696 "../src/game-view.vala"
				self->priv->highlight_y = (guint8) 9;
#line 696 "../src/game-view.vala"
				break;
#line 3904 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label52) ? _tmp64_label52 : (_tmp64_label52 = g_quark_from_static_string ("Home")))) || (_tmp65_ == ((0 != _tmp64_label53) ? _tmp64_label53 : (_tmp64_label53 = g_quark_from_static_string ("KP_Home"))))) {
#line 639 "../src/game-view.vala"
		switch (0) {
#line 3910 "game-view.c"
			default:
			{
#line 700 "../src/game-view.vala"
				self->priv->highlight_x = (guint8) 0;
#line 701 "../src/game-view.vala"
				break;
#line 3917 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label54) ? _tmp64_label54 : (_tmp64_label54 = g_quark_from_static_string ("End")))) || (_tmp65_ == ((0 != _tmp64_label55) ? _tmp64_label55 : (_tmp64_label55 = g_quark_from_static_string ("KP_End"))))) {
#line 639 "../src/game-view.vala"
		switch (0) {
#line 3923 "game-view.c"
			default:
			{
#line 704 "../src/game-view.vala"
				self->priv->highlight_x = (guint8) (self->priv->game_size - 1);
#line 705 "../src/game-view.vala"
				break;
#line 3930 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label56) ? _tmp64_label56 : (_tmp64_label56 = g_quark_from_static_string ("Page_Up")))) || (_tmp65_ == ((0 != _tmp64_label57) ? _tmp64_label57 : (_tmp64_label57 = g_quark_from_static_string ("KP_Page_Up"))))) {
#line 639 "../src/game-view.vala"
		switch (0) {
#line 3936 "game-view.c"
			default:
			{
#line 708 "../src/game-view.vala"
				self->priv->highlight_y = (guint8) 0;
#line 709 "../src/game-view.vala"
				break;
#line 3943 "game-view.c"
			}
		}
	} else if ((_tmp65_ == ((0 != _tmp64_label58) ? _tmp64_label58 : (_tmp64_label58 = g_quark_from_static_string ("Page_Down")))) || (_tmp65_ == ((0 != _tmp64_label59) ? _tmp64_label59 : (_tmp64_label59 = g_quark_from_static_string ("KP_Next"))))) {
#line 639 "../src/game-view.vala"
		switch (0) {
#line 3949 "game-view.c"
			default:
			{
#line 712 "../src/game-view.vala"
				self->priv->highlight_y = (guint8) (self->priv->game_size - 1);
#line 713 "../src/game-view.vala"
				break;
#line 3956 "game-view.c"
			}
		}
	} else {
#line 639 "../src/game-view.vala"
		switch (0) {
#line 3962 "game-view.c"
			default:
			{
#line 717 "../src/game-view.vala"
				result = FALSE;
#line 717 "../src/game-view.vala"
				_g_free0 (key);
#line 717 "../src/game-view.vala"
				return result;
#line 3971 "game-view.c"
			}
		}
	}
#line 720 "../src/game-view.vala"
	self->priv->highlight_set = TRUE;
#line 722 "../src/game-view.vala"
	_tmp88_ = key;
#line 722 "../src/game-view.vala"
	if (g_strcmp0 (_tmp88_, "Escape") == 0) {
#line 723 "../src/game-view.vala"
		self->priv->show_highlight = FALSE;
#line 3983 "game-view.c"
	} else {
#line 724 "../src/game-view.vala"
		if (self->priv->show_highlight) {
#line 725 "../src/game-view.vala"
			self->priv->highlight_state = GAME_VIEW_HIGHLIGHT_MAX;
#line 3989 "game-view.c"
		} else {
#line 727 "../src/game-view.vala"
			self->priv->show_highlight = TRUE;
#line 3993 "game-view.c"
		}
	}
#line 729 "../src/game-view.vala"
	_tmp89_ = game_view_get_board_x (self);
#line 729 "../src/game-view.vala"
	_tmp90_ = _tmp89_;
#line 729 "../src/game-view.vala"
	_tmp91_ = game_view_get_board_y (self);
#line 729 "../src/game-view.vala"
	_tmp92_ = _tmp91_;
#line 729 "../src/game-view.vala"
	gtk_widget_queue_draw_area ((GtkWidget*) self, (gint) (_tmp90_ + (old_highlight_x * self->priv->paving_size)), (gint) (_tmp92_ + (old_highlight_y * self->priv->paving_size)), self->priv->tile_size, self->priv->tile_size);
#line 733 "../src/game-view.vala"
	if (old_highlight_x != self->priv->highlight_x) {
#line 733 "../src/game-view.vala"
		_tmp93_ = TRUE;
#line 4010 "game-view.c"
	} else {
#line 734 "../src/game-view.vala"
		_tmp93_ = old_highlight_y != self->priv->highlight_y;
#line 4014 "game-view.c"
	}
#line 733 "../src/game-view.vala"
	if (_tmp93_) {
#line 4018 "game-view.c"
		gint _tmp94_;
		gint _tmp95_;
		gint _tmp96_;
		gint _tmp97_;
#line 735 "../src/game-view.vala"
		_tmp94_ = game_view_get_board_x (self);
#line 735 "../src/game-view.vala"
		_tmp95_ = _tmp94_;
#line 735 "../src/game-view.vala"
		_tmp96_ = game_view_get_board_y (self);
#line 735 "../src/game-view.vala"
		_tmp97_ = _tmp96_;
#line 735 "../src/game-view.vala"
		gtk_widget_queue_draw_area ((GtkWidget*) self, (gint) (_tmp95_ + (self->priv->highlight_x * self->priv->paving_size)), (gint) (_tmp97_ + (self->priv->highlight_y * self->priv->paving_size)), self->priv->tile_size, self->priv->tile_size);
#line 4033 "game-view.c"
	}
#line 739 "../src/game-view.vala"
	result = TRUE;
#line 739 "../src/game-view.vala"
	_g_free0 (key);
#line 739 "../src/game-view.vala"
	return result;
#line 4041 "game-view.c"
}

static gboolean
game_view_draw_scoreboard (GameView* self,
                           cairo_t* cr)
{
	gboolean result = FALSE;
	gint height = 0;
	GtkDrawingArea* _tmp0_;
	GtkDrawingArea* _tmp1_;
	gint width = 0;
	GtkDrawingArea* _tmp2_;
	GtkDrawingArea* _tmp3_;
	cairo_surface_t* surface = NULL;
	cairo_surface_t* _tmp4_;
	cairo_surface_t* _tmp5_;
	cairo_t* c = NULL;
	cairo_t* _tmp6_;
	cairo_pattern_t* _tmp7_;
	cairo_matrix_t matrix = {0};
	cairo_pattern_t* _tmp8_;
	cairo_matrix_t _tmp9_;
	cairo_pattern_t* _tmp10_;
	cairo_pattern_t* _tmp11_;
	cairo_matrix_t _tmp12_;
	cairo_pattern_t* _tmp13_;
#line 746 "../src/game-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 746 "../src/game-view.vala"
	g_return_val_if_fail (cr != NULL, FALSE);
#line 748 "../src/game-view.vala"
	_tmp0_ = game_view_get_scoreboard (self);
#line 748 "../src/game-view.vala"
	_tmp1_ = _tmp0_;
#line 748 "../src/game-view.vala"
	height = gtk_widget_get_allocated_height ((GtkWidget*) _tmp1_);
#line 749 "../src/game-view.vala"
	_tmp2_ = game_view_get_scoreboard (self);
#line 749 "../src/game-view.vala"
	_tmp3_ = _tmp2_;
#line 749 "../src/game-view.vala"
	width = gtk_widget_get_allocated_width ((GtkWidget*) _tmp3_);
#line 751 "../src/game-view.vala"
	cairo_set_line_cap (cr, CAIRO_LINE_CAP_ROUND);
#line 752 "../src/game-view.vala"
	cairo_set_line_join (cr, CAIRO_LINE_JOIN_ROUND);
#line 754 "../src/game-view.vala"
	cairo_save (cr);
#line 756 "../src/game-view.vala"
	cairo_set_source_rgba (cr, self->priv->mark_red, self->priv->mark_green, self->priv->mark_blue, 1.0);
#line 757 "../src/game-view.vala"
	cairo_set_line_width (cr, (gdouble) self->priv->mark_width);
#line 759 "../src/game-view.vala"
	cairo_translate (cr, (gdouble) 0, (self->priv->current_player_number * height) / 2.0);
#line 760 "../src/game-view.vala"
	cairo_move_to (cr, height / 4.0, height / 8.0);
#line 761 "../src/game-view.vala"
	cairo_line_to (cr, width - ((5.0 * height) / 8.0), height / 4.0);
#line 762 "../src/game-view.vala"
	cairo_line_to (cr, height / 4.0, (3.0 * height) / 8.0);
#line 763 "../src/game-view.vala"
	cairo_stroke (cr);
#line 765 "../src/game-view.vala"
	cairo_restore (cr);
#line 770 "../src/game-view.vala"
	_tmp4_ = cairo_get_target (cr);
#line 770 "../src/game-view.vala"
	_tmp5_ = cairo_surface_create_similar (_tmp4_, CAIRO_CONTENT_COLOR_ALPHA, height * 4, height * 2);
#line 770 "../src/game-view.vala"
	surface = _tmp5_;
#line 771 "../src/game-view.vala"
	_tmp6_ = cairo_create (surface);
#line 771 "../src/game-view.vala"
	c = _tmp6_;
#line 772 "../src/game-view.vala"
	game_view_load_image (self, c, height * 4, height * 2);
#line 773 "../src/game-view.vala"
	_tmp7_ = cairo_pattern_create_for_surface (surface);
#line 773 "../src/game-view.vala"
	_cairo_pattern_destroy0 (self->priv->scoreboard_tiles_pattern);
#line 773 "../src/game-view.vala"
	self->priv->scoreboard_tiles_pattern = _tmp7_;
#line 775 "../src/game-view.vala"
	cairo_translate (cr, width - (height / 2.0), (gdouble) 0);
#line 776 "../src/game-view.vala"
	cairo_matrix_init_identity (&matrix);
#line 779 "../src/game-view.vala"
	cairo_matrix_translate (&matrix, height / 2.0, (gdouble) 0);
#line 780 "../src/game-view.vala"
	_tmp8_ = self->priv->scoreboard_tiles_pattern;
#line 780 "../src/game-view.vala"
	_tmp9_ = matrix;
#line 780 "../src/game-view.vala"
	cairo_pattern_set_matrix ((cairo_pattern_t*) _tmp8_, &_tmp9_);
#line 781 "../src/game-view.vala"
	_tmp10_ = self->priv->scoreboard_tiles_pattern;
#line 781 "../src/game-view.vala"
	cairo_set_source (cr, (cairo_pattern_t*) _tmp10_);
#line 782 "../src/game-view.vala"
	cairo_rectangle (cr, (gdouble) 0, (gdouble) 0, height / 2.0, height / 2.0);
#line 783 "../src/game-view.vala"
	cairo_fill (cr);
#line 786 "../src/game-view.vala"
	cairo_matrix_translate (&matrix, (gdouble) (3 * height), (gdouble) height);
#line 787 "../src/game-view.vala"
	_tmp11_ = self->priv->scoreboard_tiles_pattern;
#line 787 "../src/game-view.vala"
	_tmp12_ = matrix;
#line 787 "../src/game-view.vala"
	cairo_pattern_set_matrix ((cairo_pattern_t*) _tmp11_, &_tmp12_);
#line 788 "../src/game-view.vala"
	_tmp13_ = self->priv->scoreboard_tiles_pattern;
#line 788 "../src/game-view.vala"
	cairo_set_source (cr, (cairo_pattern_t*) _tmp13_);
#line 789 "../src/game-view.vala"
	cairo_rectangle (cr, (gdouble) 0, height / 2.0, height / 2.0, height / 2.0);
#line 790 "../src/game-view.vala"
	cairo_fill (cr);
#line 809 "../src/game-view.vala"
	result = TRUE;
#line 809 "../src/game-view.vala"
	_cairo_destroy0 (c);
#line 809 "../src/game-view.vala"
	_cairo_surface_destroy0 (surface);
#line 809 "../src/game-view.vala"
	return result;
#line 4168 "game-view.c"
}

void
game_view_update_scoreboard (GameView* self)
{
	gint _tmp0_ = 0;
	Game* _tmp1_;
	Game* _tmp2_;
	Player _tmp3_;
	Player _tmp4_;
	GtkDrawingArea* _tmp5_;
	GtkDrawingArea* _tmp6_;
#line 812 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 812 "../src/game-view.vala"
	_vala_return_if_fail (self->priv->game_is_set, "game_is_set");
#line 815 "../src/game-view.vala"
	_tmp1_ = game_view_get_game (self);
#line 815 "../src/game-view.vala"
	_tmp2_ = _tmp1_;
#line 815 "../src/game-view.vala"
	_tmp3_ = game_get_current_color (_tmp2_);
#line 815 "../src/game-view.vala"
	_tmp4_ = _tmp3_;
#line 815 "../src/game-view.vala"
	if (_tmp4_ == PLAYER_DARK) {
#line 815 "../src/game-view.vala"
		_tmp0_ = 0;
#line 4197 "game-view.c"
	} else {
#line 815 "../src/game-view.vala"
		_tmp0_ = 1;
#line 4201 "game-view.c"
	}
#line 815 "../src/game-view.vala"
	self->priv->current_player_number = _tmp0_;
#line 816 "../src/game-view.vala"
	_tmp5_ = game_view_get_scoreboard (self);
#line 816 "../src/game-view.vala"
	_tmp6_ = _tmp5_;
#line 816 "../src/game-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp6_);
#line 4211 "game-view.c"
}

GameView*
game_view_construct (GType object_type)
{
	GameView * self = NULL;
#line 23 "../src/game-view.vala"
	self = (GameView*) g_object_new (object_type, NULL);
#line 23 "../src/game-view.vala"
	return self;
#line 4222 "game-view.c"
}

GameView*
game_view_new (void)
{
#line 23 "../src/game-view.vala"
	return game_view_construct (TYPE_GAME_VIEW);
#line 4230 "game-view.c"
}

static GtkDrawingArea*
game_view_get_scoreboard (GameView* self)
{
	GtkDrawingArea* result;
	GtkDrawingArea* _tmp0_;
#line 27 "../src/game-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "../src/game-view.vala"
	_tmp0_ = self->priv->_scoreboard;
#line 27 "../src/game-view.vala"
	result = _tmp0_;
#line 27 "../src/game-view.vala"
	return result;
#line 4246 "game-view.c"
}

static gboolean
_game_view_draw_scoreboard_gtk_widget_draw (GtkWidget* _sender,
                                            cairo_t* cr,
                                            gpointer self)
{
	gboolean result;
	result = game_view_draw_scoreboard ((GameView*) self, cr);
#line 31 "../src/game-view.vala"
	return result;
#line 4258 "game-view.c"
}

void
game_view_set_scoreboard (GameView* self,
                          GtkDrawingArea* value)
{
	GtkDrawingArea* _tmp0_;
	GtkDrawingArea* _tmp1_;
#line 28 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/game-view.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 30 "../src/game-view.vala"
	_g_object_unref0 (self->priv->_scoreboard);
#line 30 "../src/game-view.vala"
	self->priv->_scoreboard = _tmp0_;
#line 31 "../src/game-view.vala"
	_tmp1_ = self->priv->_scoreboard;
#line 31 "../src/game-view.vala"
	g_signal_connect_object ((GtkWidget*) _tmp1_, "draw", (GCallback) _game_view_draw_scoreboard_gtk_widget_draw, self, 0);
#line 4279 "game-view.c"
}

const gchar*
game_view_get_sound_flip (GameView* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 65 "../src/game-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 65 "../src/game-view.vala"
	_tmp0_ = self->priv->_sound_flip;
#line 65 "../src/game-view.vala"
	result = _tmp0_;
#line 65 "../src/game-view.vala"
	return result;
#line 4295 "game-view.c"
}

static void
game_view_set_sound_flip (GameView* self,
                          const gchar* value)
{
	gchar* _tmp0_;
#line 65 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 65 "../src/game-view.vala"
	_tmp0_ = g_strdup (value);
#line 65 "../src/game-view.vala"
	_g_free0 (self->priv->_sound_flip);
#line 65 "../src/game-view.vala"
	self->priv->_sound_flip = _tmp0_;
#line 4311 "game-view.c"
}

const gchar*
game_view_get_sound_gameover (GameView* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 66 "../src/game-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 66 "../src/game-view.vala"
	_tmp0_ = self->priv->_sound_gameover;
#line 66 "../src/game-view.vala"
	result = _tmp0_;
#line 66 "../src/game-view.vala"
	return result;
#line 4327 "game-view.c"
}

static void
game_view_set_sound_gameover (GameView* self,
                              const gchar* value)
{
	gchar* _tmp0_;
#line 66 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 66 "../src/game-view.vala"
	_tmp0_ = g_strdup (value);
#line 66 "../src/game-view.vala"
	_g_free0 (self->priv->_sound_gameover);
#line 66 "../src/game-view.vala"
	self->priv->_sound_gameover = _tmp0_;
#line 4343 "game-view.c"
}

static gint
game_view_get_board_x (GameView* self)
{
	gint result;
#line 68 "../src/game-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 68 "../src/game-view.vala"
	result = (gtk_widget_get_allocated_width ((GtkWidget*) self) - self->priv->board_size) / 2;
#line 68 "../src/game-view.vala"
	return result;
#line 4356 "game-view.c"
}

static gint
game_view_get_board_y (GameView* self)
{
	gint result;
#line 69 "../src/game-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 69 "../src/game-view.vala"
	result = (gtk_widget_get_allocated_height ((GtkWidget*) self) - self->priv->board_size) / 2;
#line 69 "../src/game-view.vala"
	return result;
#line 4369 "game-view.c"
}

Game*
game_view_get_game (GameView* self)
{
	Game* result;
	Game* _tmp0_;
#line 103 "../src/game-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 105 "../src/game-view.vala"
	if (!self->priv->game_is_set) {
#line 106 "../src/game-view.vala"
		g_assert_not_reached ();
#line 4383 "game-view.c"
	}
#line 107 "../src/game-view.vala"
	_tmp0_ = self->priv->_game;
#line 107 "../src/game-view.vala"
	result = _tmp0_;
#line 107 "../src/game-view.vala"
	return result;
#line 4391 "game-view.c"
}

static void
_game_view_game_is_complete_cb_g_object_notify (GObject* _sender,
                                                GParamSpec* pspec,
                                                gpointer self)
{
#line 124 "../src/game-view.vala"
	game_view_game_is_complete_cb ((GameView*) self);
#line 4401 "game-view.c"
}

static void
_game_view_square_changed_cb_game_square_changed (Game* _sender,
                                                  guint8 x,
                                                  guint8 y,
                                                  Player new_color,
                                                  gpointer self)
{
#line 125 "../src/game-view.vala"
	game_view_square_changed_cb ((GameView*) self, x, y, new_color);
#line 4413 "game-view.c"
}

void
game_view_set_game (GameView* self,
                    Game* value)
{
	Game* test = NULL;
	Game* _tmp0_;
	Game* _tmp2_;
	Game* _tmp3_;
	guint8 _tmp4_;
	guint8 _tmp5_;
	gint* _tmp6_;
	Game* _tmp13_;
	Game* _tmp14_;
	gboolean odd_game = FALSE;
	gboolean _tmp15_ = FALSE;
	Game* _tmp16_;
	gboolean _tmp17_;
	gboolean _tmp18_;
	guint8 _tmp19_ = 0U;
#line 109 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 111 "../src/game-view.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 111 "../src/game-view.vala"
	test = _tmp0_;
#line 112 "../src/game-view.vala"
	if (test == NULL) {
#line 113 "../src/game-view.vala"
		g_assert_not_reached ();
#line 4445 "game-view.c"
	}
#line 115 "../src/game-view.vala"
	if (self->priv->game_is_set) {
#line 4449 "game-view.c"
		Game* _tmp1_;
#line 116 "../src/game-view.vala"
		_tmp1_ = self->priv->_game;
#line 116 "../src/game-view.vala"
		g_signal_handlers_disconnect_by_func (_tmp1_, NULL, self);
#line 4455 "game-view.c"
	}
#line 117 "../src/game-view.vala"
	_tmp2_ = _g_object_ref0 (value);
#line 117 "../src/game-view.vala"
	_g_object_unref0 (self->priv->_game);
#line 117 "../src/game-view.vala"
	self->priv->_game = _tmp2_;
#line 118 "../src/game-view.vala"
	self->priv->game_is_set = TRUE;
#line 119 "../src/game-view.vala"
	_tmp3_ = self->priv->_game;
#line 119 "../src/game-view.vala"
	_tmp4_ = game_get_size (_tmp3_);
#line 119 "../src/game-view.vala"
	_tmp5_ = _tmp4_;
#line 119 "../src/game-view.vala"
	self->priv->game_size = _tmp5_;
#line 120 "../src/game-view.vala"
	_tmp6_ = g_new0 (gint, self->priv->game_size * self->priv->game_size);
#line 120 "../src/game-view.vala"
	self->priv->pixmaps = (g_free (self->priv->pixmaps), NULL);
#line 120 "../src/game-view.vala"
	self->priv->pixmaps = _tmp6_;
#line 120 "../src/game-view.vala"
	self->priv->pixmaps_length1 = self->priv->game_size;
#line 120 "../src/game-view.vala"
	self->priv->pixmaps_length2 = self->priv->game_size;
#line 4483 "game-view.c"
	{
		guint8 x = 0U;
#line 121 "../src/game-view.vala"
		x = (guint8) 0;
#line 4488 "game-view.c"
		{
			gboolean _tmp7_ = FALSE;
#line 121 "../src/game-view.vala"
			_tmp7_ = TRUE;
#line 121 "../src/game-view.vala"
			while (TRUE) {
#line 121 "../src/game-view.vala"
				if (!_tmp7_) {
#line 4497 "game-view.c"
					guint8 _tmp8_;
#line 121 "../src/game-view.vala"
					_tmp8_ = x;
#line 121 "../src/game-view.vala"
					x = _tmp8_ + 1;
#line 4503 "game-view.c"
				}
#line 121 "../src/game-view.vala"
				_tmp7_ = FALSE;
#line 121 "../src/game-view.vala"
				if (!(x < self->priv->game_size)) {
#line 121 "../src/game-view.vala"
					break;
#line 4511 "game-view.c"
				}
				{
					guint8 y = 0U;
#line 122 "../src/game-view.vala"
					y = (guint8) 0;
#line 4517 "game-view.c"
					{
						gboolean _tmp9_ = FALSE;
#line 122 "../src/game-view.vala"
						_tmp9_ = TRUE;
#line 122 "../src/game-view.vala"
						while (TRUE) {
#line 4524 "game-view.c"
							gint* _tmp11_;
							gint _tmp11__length1;
							gint _tmp11__length2;
							Game* _tmp12_;
#line 122 "../src/game-view.vala"
							if (!_tmp9_) {
#line 4531 "game-view.c"
								guint8 _tmp10_;
#line 122 "../src/game-view.vala"
								_tmp10_ = y;
#line 122 "../src/game-view.vala"
								y = _tmp10_ + 1;
#line 4537 "game-view.c"
							}
#line 122 "../src/game-view.vala"
							_tmp9_ = FALSE;
#line 122 "../src/game-view.vala"
							if (!(y < self->priv->game_size)) {
#line 122 "../src/game-view.vala"
								break;
#line 4545 "game-view.c"
							}
#line 123 "../src/game-view.vala"
							_tmp11_ = self->priv->pixmaps;
#line 123 "../src/game-view.vala"
							_tmp11__length1 = self->priv->pixmaps_length1;
#line 123 "../src/game-view.vala"
							_tmp11__length2 = self->priv->pixmaps_length2;
#line 123 "../src/game-view.vala"
							_tmp12_ = self->priv->_game;
#line 123 "../src/game-view.vala"
							_tmp11_[(x * _tmp11__length2) + y] = game_view_get_pixmap (game_get_owner (_tmp12_, x, y));
#line 4557 "game-view.c"
						}
					}
				}
			}
		}
	}
#line 124 "../src/game-view.vala"
	_tmp13_ = self->priv->_game;
#line 124 "../src/game-view.vala"
	g_signal_connect_object ((GObject*) _tmp13_, "notify::is-complete", (GCallback) _game_view_game_is_complete_cb_g_object_notify, self, 0);
#line 125 "../src/game-view.vala"
	_tmp14_ = self->priv->_game;
#line 125 "../src/game-view.vala"
	g_signal_connect_object (_tmp14_, "square-changed", (GCallback) _game_view_square_changed_cb_game_square_changed, self, 0);
#line 127 "../src/game-view.vala"
	self->priv->show_highlight = FALSE;
#line 128 "../src/game-view.vala"
	odd_game = (self->priv->game_size % 2) != 0;
#line 129 "../src/game-view.vala"
	_tmp16_ = self->priv->_game;
#line 129 "../src/game-view.vala"
	_tmp17_ = game_get_alternative_start (_tmp16_);
#line 129 "../src/game-view.vala"
	_tmp18_ = _tmp17_;
#line 129 "../src/game-view.vala"
	if (_tmp18_) {
#line 129 "../src/game-view.vala"
		_tmp15_ = TRUE;
#line 4586 "game-view.c"
	} else {
#line 129 "../src/game-view.vala"
		_tmp15_ = odd_game;
#line 4590 "game-view.c"
	}
#line 129 "../src/game-view.vala"
	self->priv->highlight_set = _tmp15_;
#line 130 "../src/game-view.vala"
	if (odd_game) {
#line 130 "../src/game-view.vala"
		_tmp19_ = (guint8) (self->priv->game_size / 2);
#line 4598 "game-view.c"
	} else {
#line 130 "../src/game-view.vala"
		_tmp19_ = (guint8) ((self->priv->game_size / 2) - 1);
#line 4602 "game-view.c"
	}
#line 130 "../src/game-view.vala"
	self->priv->highlight_x = _tmp19_;
#line 131 "../src/game-view.vala"
	self->priv->highlight_y = self->priv->highlight_x;
#line 132 "../src/game-view.vala"
	self->priv->highlight_state = (guint8) 0;
#line 134 "../src/game-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 109 "../src/game-view.vala"
	_g_object_unref0 (test);
#line 4614 "game-view.c"
}

const gchar*
game_view_get_theme (GameView* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 151 "../src/game-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 151 "../src/game-view.vala"
	_tmp0_ = self->priv->_theme;
#line 151 "../src/game-view.vala"
	result = _tmp0_;
#line 151 "../src/game-view.vala"
	return result;
#line 4630 "game-view.c"
}

void
game_view_set_theme (GameView* self,
                     const gchar* value)
{
	GKeyFile* key = NULL;
	GKeyFile* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GKeyFile* _tmp15_;
	gchar* _tmp16_;
	GtkDrawingArea* _tmp17_;
	GtkDrawingArea* _tmp18_;
	GError* _inner_error0_ = NULL;
#line 152 "../src/game-view.vala"
	g_return_if_fail (self != NULL);
#line 153 "../src/game-view.vala"
	_tmp0_ = g_key_file_new ();
#line 153 "../src/game-view.vala"
	key = _tmp0_;
#line 154 "../src/game-view.vala"
	if (value == NULL) {
#line 154 "../src/game-view.vala"
		_tmp1_ = TRUE;
#line 4655 "game-view.c"
	} else {
#line 154 "../src/game-view.vala"
		_tmp1_ = g_strcmp0 ((const gchar*) value, "default") == 0;
#line 4659 "game-view.c"
	}
#line 154 "../src/game-view.vala"
	if (_tmp1_) {
#line 155 "../src/game-view.vala"
		game_view_set_default_theme (self, &key);
#line 4665 "game-view.c"
	} else {
		{
			gchar* key_path = NULL;
			gchar* _tmp2_;
			gchar* filepath = NULL;
			const gchar* _tmp3_;
			gchar* _tmp4_;
			const gchar* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
			const gchar* _tmp8_;
			gboolean _tmp9_;
			GKeyFile* _tmp11_;
			const gchar* _tmp12_;
#line 159 "../src/game-view.vala"
			_tmp2_ = g_build_filename (DATA_DIRECTORY, "themes", "key", NULL);
#line 159 "../src/game-view.vala"
			key_path = _tmp2_;
#line 160 "../src/game-view.vala"
			_tmp3_ = key_path;
#line 160 "../src/game-view.vala"
			_tmp4_ = g_build_filename (_tmp3_, (const gchar*) value, NULL);
#line 160 "../src/game-view.vala"
			filepath = _tmp4_;
#line 161 "../src/game-view.vala"
			_tmp5_ = filepath;
#line 161 "../src/game-view.vala"
			_tmp6_ = g_path_get_dirname (_tmp5_);
#line 161 "../src/game-view.vala"
			_tmp7_ = _tmp6_;
#line 161 "../src/game-view.vala"
			_tmp8_ = key_path;
#line 161 "../src/game-view.vala"
			_tmp9_ = g_strcmp0 (_tmp7_, _tmp8_) != 0;
#line 161 "../src/game-view.vala"
			_g_free0 (_tmp7_);
#line 161 "../src/game-view.vala"
			if (_tmp9_) {
#line 4704 "game-view.c"
				GError* _tmp10_;
#line 162 "../src/game-view.vala"
				_tmp10_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_FAILED, "Theme file is not in the \"key\" directory.");
#line 162 "../src/game-view.vala"
				_inner_error0_ = _tmp10_;
#line 162 "../src/game-view.vala"
				_g_free0 (filepath);
#line 162 "../src/game-view.vala"
				_g_free0 (key_path);
#line 4714 "game-view.c"
				goto __catch4_g_error;
			}
#line 164 "../src/game-view.vala"
			_tmp11_ = key;
#line 164 "../src/game-view.vala"
			_tmp12_ = filepath;
#line 164 "../src/game-view.vala"
			g_key_file_load_from_file (_tmp11_, _tmp12_, G_KEY_FILE_NONE, &_inner_error0_);
#line 164 "../src/game-view.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 164 "../src/game-view.vala"
				_g_free0 (filepath);
#line 164 "../src/game-view.vala"
				_g_free0 (key_path);
#line 4729 "game-view.c"
				goto __catch4_g_error;
			}
#line 157 "../src/game-view.vala"
			_g_free0 (filepath);
#line 157 "../src/game-view.vala"
			_g_free0 (key_path);
#line 4736 "game-view.c"
		}
		goto __finally4;
		__catch4_g_error:
		{
			GError* e = NULL;
			GError* _tmp13_;
			const gchar* _tmp14_;
#line 157 "../src/game-view.vala"
			e = _inner_error0_;
#line 157 "../src/game-view.vala"
			_inner_error0_ = NULL;
#line 168 "../src/game-view.vala"
			_tmp13_ = e;
#line 168 "../src/game-view.vala"
			_tmp14_ = _tmp13_->message;
#line 168 "../src/game-view.vala"
			g_warning ("game-view.vala:168: Failed to load theme: %s", _tmp14_);
#line 169 "../src/game-view.vala"
			game_view_set_default_theme (self, &key);
#line 170 "../src/game-view.vala"
			value = "default";
#line 157 "../src/game-view.vala"
			_g_error_free0 (e);
#line 4760 "game-view.c"
		}
		__finally4:
#line 157 "../src/game-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 157 "../src/game-view.vala"
			_g_key_file_unref0 (key);
#line 157 "../src/game-view.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 157 "../src/game-view.vala"
			g_clear_error (&_inner_error0_);
#line 157 "../src/game-view.vala"
			return;
#line 4773 "game-view.c"
		}
	}
#line 173 "../src/game-view.vala"
	_tmp15_ = key;
#line 173 "../src/game-view.vala"
	game_view_load_theme (self, _tmp15_);
#line 174 "../src/game-view.vala"
	_tmp16_ = g_strdup (value);
#line 174 "../src/game-view.vala"
	_g_free0 (self->priv->_theme);
#line 174 "../src/game-view.vala"
	self->priv->_theme = _tmp16_;
#line 177 "../src/game-view.vala"
	_cairo_pattern_destroy0 (self->priv->tiles_pattern);
#line 177 "../src/game-view.vala"
	self->priv->tiles_pattern = NULL;
#line 179 "../src/game-view.vala"
	_tmp17_ = game_view_get_scoreboard (self);
#line 179 "../src/game-view.vala"
	_tmp18_ = _tmp17_;
#line 179 "../src/game-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp18_);
#line 180 "../src/game-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 152 "../src/game-view.vala"
	_g_key_file_unref0 (key);
#line 4800 "game-view.c"
}

static void
g_cclosure_user_marshal_VOID__UCHAR_UCHAR (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__UCHAR_UCHAR) (gpointer data1, guint8 arg_1, guint8 arg_2, gpointer data2);
	register GMarshalFunc_VOID__UCHAR_UCHAR callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 23 "../src/game-view.vala"
	g_return_if_fail (n_param_values == 3);
#line 23 "../src/game-view.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 23 "../src/game-view.vala"
		data1 = closure->data;
#line 23 "../src/game-view.vala"
		data2 = param_values->data[0].v_pointer;
#line 4825 "game-view.c"
	} else {
#line 23 "../src/game-view.vala"
		data1 = param_values->data[0].v_pointer;
#line 23 "../src/game-view.vala"
		data2 = closure->data;
#line 4831 "game-view.c"
	}
#line 23 "../src/game-view.vala"
	callback = (GMarshalFunc_VOID__UCHAR_UCHAR) (marshal_data ? marshal_data : cc->callback);
#line 23 "../src/game-view.vala"
	callback (data1, g_value_get_uchar (param_values + 1), g_value_get_uchar (param_values + 2), data2);
#line 4837 "game-view.c"
}

static GObject *
game_view_constructor (GType type,
                       guint n_construct_properties,
                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GameView * self;
#line 138 "../src/game-view.vala"
	parent_class = G_OBJECT_CLASS (game_view_parent_class);
#line 138 "../src/game-view.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 138 "../src/game-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME_VIEW, GameView);
#line 140 "../src/game-view.vala"
	gtk_widget_set_events ((GtkWidget*) self, (gint) ((GDK_EXPOSURE_MASK | GDK_BUTTON_PRESS_MASK) | GDK_BUTTON_RELEASE_MASK));
#line 141 "../src/game-view.vala"
	gtk_widget_set_size_request ((GtkWidget*) self, 350, 350);
#line 138 "../src/game-view.vala"
	return obj;
#line 4860 "game-view.c"
}

static void
game_view_class_init (GameViewClass * klass,
                      gpointer klass_data)
{
#line 23 "../src/game-view.vala"
	game_view_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/game-view.vala"
	g_type_class_adjust_private_offset (klass, &GameView_private_offset);
#line 23 "../src/game-view.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) game_view_real_draw;
#line 23 "../src/game-view.vala"
	((GtkWidgetClass *) klass)->button_press_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) game_view_real_button_press_event;
#line 23 "../src/game-view.vala"
	((GtkWidgetClass *) klass)->key_press_event = (gboolean (*) (GtkWidget*, GdkEventKey*)) game_view_real_key_press_event;
#line 23 "../src/game-view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_game_view_get_property;
#line 23 "../src/game-view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_game_view_set_property;
#line 23 "../src/game-view.vala"
	G_OBJECT_CLASS (klass)->constructor = game_view_constructor;
#line 23 "../src/game-view.vala"
	G_OBJECT_CLASS (klass)->finalize = game_view_finalize;
#line 23 "../src/game-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_VIEW_SCOREBOARD_PROPERTY, game_view_properties[GAME_VIEW_SCOREBOARD_PROPERTY] = g_param_spec_object ("scoreboard", "scoreboard", "scoreboard", gtk_drawing_area_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 23 "../src/game-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_VIEW_SOUND_FLIP_PROPERTY, game_view_properties[GAME_VIEW_SOUND_FLIP_PROPERTY] = g_param_spec_string ("sound-flip", "sound-flip", "sound-flip", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 23 "../src/game-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_VIEW_SOUND_GAMEOVER_PROPERTY, game_view_properties[GAME_VIEW_SOUND_GAMEOVER_PROPERTY] = g_param_spec_string ("sound-gameover", "sound-gameover", "sound-gameover", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 23 "../src/game-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_VIEW_GAME_PROPERTY, game_view_properties[GAME_VIEW_GAME_PROPERTY] = g_param_spec_object ("game", "game", "game", TYPE_GAME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 23 "../src/game-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_VIEW_THEME_PROPERTY, game_view_properties[GAME_VIEW_THEME_PROPERTY] = g_param_spec_string ("theme", "theme", "theme", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 23 "../src/game-view.vala"
	game_view_signals[GAME_VIEW_MOVE_SIGNAL] = g_signal_new ("move", TYPE_GAME_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UCHAR_UCHAR, G_TYPE_NONE, 2, G_TYPE_UCHAR, G_TYPE_UCHAR);
#line 4897 "game-view.c"
}

static void
game_view_instance_init (GameView * self,
                         gpointer klass)
{
#line 23 "../src/game-view.vala"
	self->priv = game_view_get_instance_private (self);
#line 38 "../src/game-view.vala"
	self->priv->background_red = 0.2;
#line 39 "../src/game-view.vala"
	self->priv->background_green = 0.6;
#line 40 "../src/game-view.vala"
	self->priv->background_blue = 0.4;
#line 41 "../src/game-view.vala"
	self->priv->background_radius = 0;
#line 43 "../src/game-view.vala"
	self->priv->mark_red = 0.2;
#line 44 "../src/game-view.vala"
	self->priv->mark_green = 0.6;
#line 45 "../src/game-view.vala"
	self->priv->mark_blue = 0.4;
#line 46 "../src/game-view.vala"
	self->priv->mark_width = 2;
#line 48 "../src/game-view.vala"
	self->priv->border_red = 0.1;
#line 49 "../src/game-view.vala"
	self->priv->border_green = 0.1;
#line 50 "../src/game-view.vala"
	self->priv->border_blue = 0.1;
#line 51 "../src/game-view.vala"
	self->priv->border_width = 3;
#line 53 "../src/game-view.vala"
	self->priv->spacing_red = 0.1;
#line 54 "../src/game-view.vala"
	self->priv->spacing_green = 0.3;
#line 55 "../src/game-view.vala"
	self->priv->spacing_blue = 0.2;
#line 56 "../src/game-view.vala"
	self->priv->spacing_width = 2;
#line 58 "../src/game-view.vala"
	self->priv->highlight_red = 0.1;
#line 59 "../src/game-view.vala"
	self->priv->highlight_green = 0.3;
#line 60 "../src/game-view.vala"
	self->priv->highlight_blue = 0.2;
#line 61 "../src/game-view.vala"
	self->priv->highlight_alpha = 0.4;
#line 83 "../src/game-view.vala"
	self->priv->render_size = (guint) 0;
#line 84 "../src/game-view.vala"
	self->priv->tiles_pattern = NULL;
#line 85 "../src/game-view.vala"
	self->priv->scoreboard_tiles_pattern = NULL;
#line 91 "../src/game-view.vala"
	self->priv->animate_timeout = (guint) 0;
#line 94 "../src/game-view.vala"
	self->priv->current_player_number = 0;
#line 98 "../src/game-view.vala"
	self->priv->game_is_set = FALSE;
#line 148 "../src/game-view.vala"
	self->priv->_theme = NULL;
#line 510 "../src/game-view.vala"
	self->priv->flip_final_result_now = FALSE;
#line 4962 "game-view.c"
}

static void
game_view_finalize (GObject * obj)
{
	GameView * self;
#line 23 "../src/game-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME_VIEW, GameView);
#line 25 "../src/game-view.vala"
	_g_object_unref0 (self->priv->_scoreboard);
#line 36 "../src/game-view.vala"
	_g_free0 (self->priv->pieces_file);
#line 65 "../src/game-view.vala"
	_g_free0 (self->priv->_sound_flip);
#line 66 "../src/game-view.vala"
	_g_free0 (self->priv->_sound_gameover);
#line 84 "../src/game-view.vala"
	_cairo_pattern_destroy0 (self->priv->tiles_pattern);
#line 85 "../src/game-view.vala"
	_cairo_pattern_destroy0 (self->priv->scoreboard_tiles_pattern);
#line 88 "../src/game-view.vala"
	self->priv->pixmaps = (g_free (self->priv->pixmaps), NULL);
#line 100 "../src/game-view.vala"
	_g_object_unref0 (self->priv->_game);
#line 148 "../src/game-view.vala"
	_g_free0 (self->priv->_theme);
#line 23 "../src/game-view.vala"
	G_OBJECT_CLASS (game_view_parent_class)->finalize (obj);
#line 4991 "game-view.c"
}

GType
game_view_get_type (void)
{
	static volatile gsize game_view_type_id__volatile = 0;
	if (g_once_init_enter (&game_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GameViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameView), 0, (GInstanceInitFunc) game_view_instance_init, NULL };
		GType game_view_type_id;
		game_view_type_id = g_type_register_static (gtk_drawing_area_get_type (), "GameView", &g_define_type_info, 0);
		GameView_private_offset = g_type_add_instance_private (game_view_type_id, sizeof (GameViewPrivate));
		g_once_init_leave (&game_view_type_id__volatile, game_view_type_id);
	}
	return game_view_type_id__volatile;
}

static void
_vala_game_view_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	GameView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME_VIEW, GameView);
#line 23 "../src/game-view.vala"
	switch (property_id) {
#line 23 "../src/game-view.vala"
		case GAME_VIEW_SCOREBOARD_PROPERTY:
#line 23 "../src/game-view.vala"
		g_value_set_object (value, game_view_get_scoreboard (self));
#line 23 "../src/game-view.vala"
		break;
#line 23 "../src/game-view.vala"
		case GAME_VIEW_SOUND_FLIP_PROPERTY:
#line 23 "../src/game-view.vala"
		g_value_set_string (value, game_view_get_sound_flip (self));
#line 23 "../src/game-view.vala"
		break;
#line 23 "../src/game-view.vala"
		case GAME_VIEW_SOUND_GAMEOVER_PROPERTY:
#line 23 "../src/game-view.vala"
		g_value_set_string (value, game_view_get_sound_gameover (self));
#line 23 "../src/game-view.vala"
		break;
#line 23 "../src/game-view.vala"
		case GAME_VIEW_GAME_PROPERTY:
#line 23 "../src/game-view.vala"
		g_value_set_object (value, game_view_get_game (self));
#line 23 "../src/game-view.vala"
		break;
#line 23 "../src/game-view.vala"
		case GAME_VIEW_THEME_PROPERTY:
#line 23 "../src/game-view.vala"
		g_value_set_string (value, game_view_get_theme (self));
#line 23 "../src/game-view.vala"
		break;
#line 5048 "game-view.c"
		default:
#line 23 "../src/game-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/game-view.vala"
		break;
#line 5054 "game-view.c"
	}
}

static void
_vala_game_view_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	GameView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME_VIEW, GameView);
#line 23 "../src/game-view.vala"
	switch (property_id) {
#line 23 "../src/game-view.vala"
		case GAME_VIEW_SCOREBOARD_PROPERTY:
#line 23 "../src/game-view.vala"
		game_view_set_scoreboard (self, g_value_get_object (value));
#line 23 "../src/game-view.vala"
		break;
#line 23 "../src/game-view.vala"
		case GAME_VIEW_SOUND_FLIP_PROPERTY:
#line 23 "../src/game-view.vala"
		game_view_set_sound_flip (self, g_value_get_string (value));
#line 23 "../src/game-view.vala"
		break;
#line 23 "../src/game-view.vala"
		case GAME_VIEW_SOUND_GAMEOVER_PROPERTY:
#line 23 "../src/game-view.vala"
		game_view_set_sound_gameover (self, g_value_get_string (value));
#line 23 "../src/game-view.vala"
		break;
#line 23 "../src/game-view.vala"
		case GAME_VIEW_GAME_PROPERTY:
#line 23 "../src/game-view.vala"
		game_view_set_game (self, g_value_get_object (value));
#line 23 "../src/game-view.vala"
		break;
#line 23 "../src/game-view.vala"
		case GAME_VIEW_THEME_PROPERTY:
#line 23 "../src/game-view.vala"
		game_view_set_theme (self, g_value_get_string (value));
#line 23 "../src/game-view.vala"
		break;
#line 5098 "game-view.c"
		default:
#line 23 "../src/game-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/game-view.vala"
		break;
#line 5104 "game-view.c"
	}
}

